<?php
 namespace PHPUnit\Framework\Constraint; use PHPUnit\Framework\ExpectationFailedException; use PHPUnit\Util\InvalidArgumentHelper; use SebastianBergmann; class IsEqual extends Constraint { protected $value; protected $delta = 0.0; protected $maxDepth = 10; protected $canonicalize = false; protected $ignoreCase = false; protected $lastFailure; public function __construct($value, $delta = 0.0, $maxDepth = 10, $canonicalize = false, $ignoreCase = false) { parent::__construct(); if (!\is_numeric($delta)) { throw InvalidArgumentHelper::factory(2, 'numeric'); } if (!\is_int($maxDepth)) { throw InvalidArgumentHelper::factory(3, 'integer'); } if (!\is_bool($canonicalize)) { throw InvalidArgumentHelper::factory(4, 'boolean'); } if (!\is_bool($ignoreCase)) { throw InvalidArgumentHelper::factory(5, 'boolean'); } $this->value = $value; $this->delta = $delta; $this->maxDepth = $maxDepth; $this->canonicalize = $canonicalize; $this->ignoreCase = $ignoreCase; } public function evaluate($other, $description = '', $returnResult = false) { if ($this->value === $other) { return true; } $comparatorFactory = SebastianBergmann\Comparator\Factory::getInstance(); try { $comparator = $comparatorFactory->getComparatorFor( $this->value, $other ); $comparator->assertEquals( $this->value, $other, $this->delta, $this->canonicalize, $this->ignoreCase ); } catch (SebastianBergmann\Comparator\ComparisonFailure $f) { if ($returnResult) { return false; } throw new ExpectationFailedException( \trim($description . "\n" . $f->getMessage()), $f ); } return true; } public function toString() { $delta = ''; if (\is_string($this->value)) { if (\strpos($this->value, "\n") !== false) { return 'is equal to <text>'; } return \sprintf( 'is equal to "%s"', $this->value ); } if ($this->delta != 0) { $delta = \sprintf( ' with delta <%F>', $this->delta ); } return \sprintf( 'is equal to %s%s', $this->exporter->export($this->value), $delta ); } } 