<?php
 namespace PHPUnit\Util\TestDox; use PHPUnit\Framework\AssertionFailedError; use PHPUnit\Framework\Test; use PHPUnit\Framework\TestCase; use PHPUnit\Framework\TestListener; use PHPUnit\Framework\TestSuite; use PHPUnit\Framework\Warning; use PHPUnit\Framework\WarningTestCase; use PHPUnit\Runner\BaseTestRunner; use PHPUnit\Util\Printer; abstract class ResultPrinter extends Printer implements TestListener { protected $prettifier; protected $testClass = ''; protected $testStatus; protected $tests = []; protected $successful = 0; protected $warned = 0; protected $failed = 0; protected $risky = 0; protected $skipped = 0; protected $incomplete = 0; protected $currentTestClassPrettified; protected $currentTestMethodPrettified; private $groups; private $excludeGroups; public function __construct($out = null, array $groups = [], array $excludeGroups = []) { parent::__construct($out); $this->groups = $groups; $this->excludeGroups = $excludeGroups; $this->prettifier = new NamePrettifier; $this->startRun(); } public function flush() { $this->doEndClass(); $this->endRun(); parent::flush(); } public function addError(Test $test, \Exception $e, $time) { if (!$this->isOfInterest($test)) { return; } $this->testStatus = BaseTestRunner::STATUS_ERROR; $this->failed++; } public function addWarning(Test $test, Warning $e, $time) { if (!$this->isOfInterest($test)) { return; } $this->testStatus = BaseTestRunner::STATUS_WARNING; $this->warned++; } public function addFailure(Test $test, AssertionFailedError $e, $time) { if (!$this->isOfInterest($test)) { return; } $this->testStatus = BaseTestRunner::STATUS_FAILURE; $this->failed++; } public function addIncompleteTest(Test $test, \Exception $e, $time) { if (!$this->isOfInterest($test)) { return; } $this->testStatus = BaseTestRunner::STATUS_INCOMPLETE; $this->incomplete++; } public function addRiskyTest(Test $test, \Exception $e, $time) { if (!$this->isOfInterest($test)) { return; } $this->testStatus = BaseTestRunner::STATUS_RISKY; $this->risky++; } public function addSkippedTest(Test $test, \Exception $e, $time) { if (!$this->isOfInterest($test)) { return; } $this->testStatus = BaseTestRunner::STATUS_SKIPPED; $this->skipped++; } public function startTestSuite(TestSuite $suite) { } public function endTestSuite(TestSuite $suite) { } public function startTest(Test $test) { if (!$this->isOfInterest($test)) { return; } $class = \get_class($test); if ($this->testClass != $class) { if ($this->testClass != '') { $this->doEndClass(); } $classAnnotations = \PHPUnit\Util\Test::parseTestMethodAnnotations($class); if (isset($classAnnotations['class']['testdox'][0])) { $this->currentTestClassPrettified = $classAnnotations['class']['testdox'][0]; } else { $this->currentTestClassPrettified = $this->prettifier->prettifyTestClass($class); } $this->startClass($class); $this->testClass = $class; $this->tests = []; } if ($test instanceof TestCase) { $annotations = $test->getAnnotations(); if (isset($annotations['method']['testdox'][0])) { $this->currentTestMethodPrettified = $annotations['method']['testdox'][0]; } else { $this->currentTestMethodPrettified = $this->prettifier->prettifyTestMethod($test->getName(false)); } if ($test->usesDataProvider()) { $this->currentTestMethodPrettified .= ' ' . $test->dataDescription(); } } $this->testStatus = BaseTestRunner::STATUS_PASSED; } public function endTest(Test $test, $time) { if (!$this->isOfInterest($test)) { return; } if (!isset($this->tests[$this->currentTestMethodPrettified])) { if ($this->testStatus == BaseTestRunner::STATUS_PASSED) { $this->tests[$this->currentTestMethodPrettified]['success'] = 1; $this->tests[$this->currentTestMethodPrettified]['failure'] = 0; } else { $this->tests[$this->currentTestMethodPrettified]['success'] = 0; $this->tests[$this->currentTestMethodPrettified]['failure'] = 1; } } else { if ($this->testStatus == BaseTestRunner::STATUS_PASSED) { $this->tests[$this->currentTestMethodPrettified]['success']++; } else { $this->tests[$this->currentTestMethodPrettified]['failure']++; } } $this->currentTestClassPrettified = null; $this->currentTestMethodPrettified = null; } protected function doEndClass() { foreach ($this->tests as $name => $data) { $this->onTest($name, $data['failure'] == 0); } $this->endClass($this->testClass); } protected function startRun() { } protected function startClass($name) { } protected function onTest($name, $success = true) { } protected function endClass($name) { } protected function endRun() { } private function isOfInterest(Test $test) { if (!$test instanceof TestCase) { return false; } if ($test instanceof WarningTestCase) { return false; } if (!empty($this->groups)) { foreach ($test->getGroups() as $group) { if (\in_array($group, $this->groups)) { return true; } } return false; } if (!empty($this->excludeGroups)) { foreach ($test->getGroups() as $group) { if (\in_array($group, $this->excludeGroups)) { return false; } } return true; } return true; } } 