<?php
 namespace Doctrine\Common\Cache; use function apcu_cache_info; use function apcu_clear_cache; use function apcu_delete; use function apcu_exists; use function apcu_fetch; use function apcu_sma_info; use function apcu_store; use function count; class ApcuCache extends CacheProvider { protected function doFetch($id) { return apcu_fetch($id); } protected function doContains($id) { return apcu_exists($id); } protected function doSave($id, $data, $lifeTime = 0) { return apcu_store($id, $data, $lifeTime); } protected function doDelete($id) { return apcu_delete($id) || ! apcu_exists($id); } protected function doDeleteMultiple(array $keys) { $result = apcu_delete($keys); return $result !== false && count($result) !== count($keys); } protected function doFlush() { return apcu_clear_cache(); } protected function doFetchMultiple(array $keys) { return apcu_fetch($keys) ?: []; } protected function doSaveMultiple(array $keysAndValues, $lifetime = 0) { $result = apcu_store($keysAndValues, null, $lifetime); return empty($result); } protected function doGetStats() { $info = apcu_cache_info(true); $sma = apcu_sma_info(); return [ Cache::STATS_HITS => $info['num_hits'], Cache::STATS_MISSES => $info['num_misses'], Cache::STATS_UPTIME => $info['start_time'], Cache::STATS_MEMORY_USAGE => $info['mem_size'], Cache::STATS_MEMORY_AVAILABLE => $sma['avail_mem'], ]; } } 