<?php
 namespace Doctrine\Common\Cache; use function array_values; use function count; use function iterator_to_array; class ChainCache extends CacheProvider { private $cacheProviders = []; public function __construct($cacheProviders = []) { $this->cacheProviders = $cacheProviders instanceof \Traversable ? iterator_to_array($cacheProviders, false) : array_values($cacheProviders); } public function setNamespace($namespace) { parent::setNamespace($namespace); foreach ($this->cacheProviders as $cacheProvider) { $cacheProvider->setNamespace($namespace); } } protected function doFetch($id) { foreach ($this->cacheProviders as $key => $cacheProvider) { if ($cacheProvider->doContains($id)) { $value = $cacheProvider->doFetch($id); for ($subKey = $key - 1; $subKey >= 0; $subKey--) { $this->cacheProviders[$subKey]->doSave($id, $value); } return $value; } } return false; } protected function doFetchMultiple(array $keys) { $traversedProviders = []; $keysCount = count($keys); $fetchedValues = []; foreach ($this->cacheProviders as $key => $cacheProvider) { $fetchedValues = $cacheProvider->doFetchMultiple($keys); if (count($fetchedValues) === $keysCount) { foreach ($traversedProviders as $previousCacheProvider) { $previousCacheProvider->doSaveMultiple($fetchedValues); } return $fetchedValues; } $traversedProviders[] = $cacheProvider; } return $fetchedValues; } protected function doContains($id) { foreach ($this->cacheProviders as $cacheProvider) { if ($cacheProvider->doContains($id)) { return true; } } return false; } protected function doSave($id, $data, $lifeTime = 0) { $stored = true; foreach ($this->cacheProviders as $cacheProvider) { $stored = $cacheProvider->doSave($id, $data, $lifeTime) && $stored; } return $stored; } protected function doSaveMultiple(array $keysAndValues, $lifetime = 0) { $stored = true; foreach ($this->cacheProviders as $cacheProvider) { $stored = $cacheProvider->doSaveMultiple($keysAndValues, $lifetime) && $stored; } return $stored; } protected function doDelete($id) { $deleted = true; foreach ($this->cacheProviders as $cacheProvider) { $deleted = $cacheProvider->doDelete($id) && $deleted; } return $deleted; } protected function doDeleteMultiple(array $keys) { $deleted = true; foreach ($this->cacheProviders as $cacheProvider) { $deleted = $cacheProvider->doDeleteMultiple($keys) && $deleted; } return $deleted; } protected function doFlush() { $flushed = true; foreach ($this->cacheProviders as $cacheProvider) { $flushed = $cacheProvider->doFlush() && $flushed; } return $flushed; } protected function doGetStats() { $stats = []; foreach ($this->cacheProviders as $cacheProvider) { $stats[] = $cacheProvider->doGetStats(); } return $stats; } } 