<?php
 namespace Doctrine\Common\Cache; use function is_object; use function method_exists; use function restore_error_handler; use function serialize; use function set_error_handler; use function sprintf; use function time; use function var_export; class PhpFileCache extends FileCache { public const EXTENSION = '.doctrinecache.php'; private static $emptyErrorHandler; public function __construct($directory, $extension = self::EXTENSION, $umask = 0002) { parent::__construct($directory, $extension, $umask); self::$emptyErrorHandler = function () { }; } protected function doFetch($id) { $value = $this->includeFileForId($id); if ($value === null) { return false; } if ($value['lifetime'] !== 0 && $value['lifetime'] < time()) { return false; } return $value['data']; } protected function doContains($id) { $value = $this->includeFileForId($id); if ($value === null) { return false; } return $value['lifetime'] === 0 || $value['lifetime'] > time(); } protected function doSave($id, $data, $lifeTime = 0) { if ($lifeTime > 0) { $lifeTime = time() + $lifeTime; } $filename = $this->getFilename($id); $value = [ 'lifetime' => $lifeTime, 'data' => $data, ]; if (is_object($data) && method_exists($data, '__set_state')) { $value = var_export($value, true); $code = sprintf('<?php return %s;', $value); } else { $value = var_export(serialize($value), true); $code = sprintf('<?php return unserialize(%s);', $value); } return $this->writeFile($filename, $code); } private function includeFileForId(string $id) : ?array { $fileName = $this->getFilename($id); set_error_handler(self::$emptyErrorHandler); $value = include $fileName; restore_error_handler(); if (! isset($value['lifetime'])) { return null; } return $value; } } 