<?php
 namespace Doctrine\Common\Cache; use Redis; use function array_combine; use function defined; use function extension_loaded; use function is_bool; class RedisCache extends CacheProvider { private $redis; public function setRedis(Redis $redis) { $redis->setOption(Redis::OPT_SERIALIZER, $this->getSerializerValue()); $this->redis = $redis; } public function getRedis() { return $this->redis; } protected function doFetch($id) { return $this->redis->get($id); } protected function doFetchMultiple(array $keys) { $fetchedItems = array_combine($keys, $this->redis->mget($keys)); $foundItems = []; foreach ($fetchedItems as $key => $value) { if ($value === false && ! $this->redis->exists($key)) { continue; } $foundItems[$key] = $value; } return $foundItems; } protected function doSaveMultiple(array $keysAndValues, $lifetime = 0) { if ($lifetime) { $success = true; foreach ($keysAndValues as $key => $value) { if ($this->redis->setex($key, $lifetime, $value)) { continue; } $success = false; } return $success; } return (bool) $this->redis->mset($keysAndValues); } protected function doContains($id) { $exists = $this->redis->exists($id); if (is_bool($exists)) { return $exists; } return $exists > 0; } protected function doSave($id, $data, $lifeTime = 0) { if ($lifeTime > 0) { return $this->redis->setex($id, $lifeTime, $data); } return $this->redis->set($id, $data); } protected function doDelete($id) { return $this->redis->delete($id) >= 0; } protected function doDeleteMultiple(array $keys) { return $this->redis->delete($keys) >= 0; } protected function doFlush() { return $this->redis->flushDB(); } protected function doGetStats() { $info = $this->redis->info(); return [ Cache::STATS_HITS => $info['keyspace_hits'], Cache::STATS_MISSES => $info['keyspace_misses'], Cache::STATS_UPTIME => $info['uptime_in_seconds'], Cache::STATS_MEMORY_USAGE => $info['used_memory'], Cache::STATS_MEMORY_AVAILABLE => false, ]; } protected function getSerializerValue() { if (defined('Redis::SERIALIZER_IGBINARY') && extension_loaded('igbinary')) { return Redis::SERIALIZER_IGBINARY; } return Redis::SERIALIZER_PHP; } } 