<?php
 namespace Doctrine\DBAL\Driver; use Doctrine\DBAL\DBALException; use Doctrine\DBAL\Driver; use Doctrine\DBAL\Exception; use Doctrine\DBAL\Platforms\MariaDb1027Platform; use Doctrine\DBAL\Platforms\MySQL57Platform; use Doctrine\DBAL\Platforms\MySQL80Platform; use Doctrine\DBAL\Platforms\MySqlPlatform; use Doctrine\DBAL\Schema\MySqlSchemaManager; use Doctrine\DBAL\VersionAwarePlatformDriver; use function preg_match; use function stripos; use function version_compare; abstract class AbstractMySQLDriver implements Driver, ExceptionConverterDriver, VersionAwarePlatformDriver { public function convertException($message, DriverException $exception) { switch ($exception->getErrorCode()) { case '1213': return new Exception\DeadlockException($message, $exception); case '1205': return new Exception\LockWaitTimeoutException($message, $exception); case '1050': return new Exception\TableExistsException($message, $exception); case '1051': case '1146': return new Exception\TableNotFoundException($message, $exception); case '1216': case '1217': case '1451': case '1452': case '1701': return new Exception\ForeignKeyConstraintViolationException($message, $exception); case '1062': case '1557': case '1569': case '1586': return new Exception\UniqueConstraintViolationException($message, $exception); case '1054': case '1166': case '1611': return new Exception\InvalidFieldNameException($message, $exception); case '1052': case '1060': case '1110': return new Exception\NonUniqueFieldNameException($message, $exception); case '1064': case '1149': case '1287': case '1341': case '1342': case '1343': case '1344': case '1382': case '1479': case '1541': case '1554': case '1626': return new Exception\SyntaxErrorException($message, $exception); case '1044': case '1045': case '1046': case '1049': case '1095': case '1142': case '1143': case '1227': case '1370': case '1429': case '2002': case '2005': return new Exception\ConnectionException($message, $exception); case '1048': case '1121': case '1138': case '1171': case '1252': case '1263': case '1364': case '1566': return new Exception\NotNullConstraintViolationException($message, $exception); } return new Exception\DriverException($message, $exception); } public function createDatabasePlatformForVersion($version) { $mariadb = false !== stripos($version, 'mariadb'); if ($mariadb && version_compare($this->getMariaDbMysqlVersionNumber($version), '10.2.7', '>=')) { return new MariaDb1027Platform(); } if (! $mariadb) { $oracleMysqlVersion = $this->getOracleMysqlVersionNumber($version); if (version_compare($oracleMysqlVersion, '8', '>=')) { return new MySQL80Platform(); } if (version_compare($oracleMysqlVersion, '5.7.9', '>=')) { return new MySQL57Platform(); } } return $this->getDatabasePlatform(); } private function getOracleMysqlVersionNumber(string $versionString) : string { if ( ! preg_match( '/^(?P<major>\d+)(?:\.(?P<minor>\d+)(?:\.(?P<patch>\d+))?)?/', $versionString, $versionParts )) { throw DBALException::invalidPlatformVersionSpecified( $versionString, '<major_version>.<minor_version>.<patch_version>' ); } $majorVersion = $versionParts['major']; $minorVersion = $versionParts['minor'] ?? 0; $patchVersion = $versionParts['patch'] ?? null; if ('5' === $majorVersion && '7' === $minorVersion && null === $patchVersion) { $patchVersion = '9'; } return $majorVersion . '.' . $minorVersion . '.' . $patchVersion; } private function getMariaDbMysqlVersionNumber(string $versionString) : string { if ( ! preg_match( '/^(?:5\.5\.5-)?(mariadb-)?(?P<major>\d+)\.(?P<minor>\d+)\.(?P<patch>\d+)/i', $versionString, $versionParts )) { throw DBALException::invalidPlatformVersionSpecified( $versionString, '^(?:5\.5\.5-)?(mariadb-)?<major_version>.<minor_version>.<patch_version>' ); } return $versionParts['major'] . '.' . $versionParts['minor'] . '.' . $versionParts['patch']; } public function getDatabase(\Doctrine\DBAL\Connection $conn) { $params = $conn->getParams(); return $params['dbname'] ?? $conn->query('SELECT DATABASE()')->fetchColumn(); } public function getDatabasePlatform() { return new MySqlPlatform(); } public function getSchemaManager(\Doctrine\DBAL\Connection $conn) { return new MySqlSchemaManager($conn); } } 