<?php
 namespace Doctrine\DBAL\Driver\OCI8; use Doctrine\DBAL\Driver\Connection; use Doctrine\DBAL\Driver\ServerInfoAwareConnection; use Doctrine\DBAL\ParameterType; use const OCI_COMMIT_ON_SUCCESS; use const OCI_DEFAULT; use const OCI_NO_AUTO_COMMIT; use function addcslashes; use function define; use function defined; use function func_get_args; use function is_float; use function is_int; use function oci_commit; use function oci_connect; use function oci_error; use function oci_pconnect; use function oci_rollback; use function oci_server_version; use function preg_match; use function sprintf; use function str_replace; class OCI8Connection implements Connection, ServerInfoAwareConnection { protected $dbh; protected $executeMode = OCI_COMMIT_ON_SUCCESS; public function __construct($username, $password, $db, $charset = null, $sessionMode = OCI_DEFAULT, $persistent = false) { if (!defined('OCI_NO_AUTO_COMMIT')) { define('OCI_NO_AUTO_COMMIT', 0); } $this->dbh = $persistent ? @oci_pconnect($username, $password, $db, $charset, $sessionMode) : @oci_connect($username, $password, $db, $charset, $sessionMode); if ( ! $this->dbh) { throw OCI8Exception::fromErrorInfo(oci_error()); } } public function getServerVersion() { if ( ! preg_match('/\s+(\d+\.\d+\.\d+\.\d+\.\d+)\s+/', oci_server_version($this->dbh), $version)) { throw new \UnexpectedValueException( sprintf( 'Unexpected database version string "%s". Cannot parse an appropriate version number from it. ' . 'Please report this database version string to the Doctrine team.', oci_server_version($this->dbh) ) ); } return $version[1]; } public function requiresQueryForServerVersion() { return false; } public function prepare($prepareString) { return new OCI8Statement($this->dbh, $prepareString, $this); } public function query() { $args = func_get_args(); $sql = $args[0]; $stmt = $this->prepare($sql); $stmt->execute(); return $stmt; } public function quote($value, $type = ParameterType::STRING) { if (is_int($value) || is_float($value)) { return $value; } $value = str_replace("'", "''", $value); return "'" . addcslashes($value, "\000\n\r\\\032") . "'"; } public function exec($statement) { $stmt = $this->prepare($statement); $stmt->execute(); return $stmt->rowCount(); } public function lastInsertId($name = null) { if ($name === null) { return false; } $sql = 'SELECT ' . $name . '.CURRVAL FROM DUAL'; $stmt = $this->query($sql); $result = $stmt->fetchColumn(); if ($result === false) { throw new OCI8Exception("lastInsertId failed: Query was executed but no result was returned."); } return (int) $result; } public function getExecuteMode() { return $this->executeMode; } public function beginTransaction() { $this->executeMode = OCI_NO_AUTO_COMMIT; return true; } public function commit() { if (!oci_commit($this->dbh)) { throw OCI8Exception::fromErrorInfo($this->errorInfo()); } $this->executeMode = OCI_COMMIT_ON_SUCCESS; return true; } public function rollBack() { if (!oci_rollback($this->dbh)) { throw OCI8Exception::fromErrorInfo($this->errorInfo()); } $this->executeMode = OCI_COMMIT_ON_SUCCESS; return true; } public function errorCode() { $error = oci_error($this->dbh); if ($error !== false) { $error = $error['code']; } return $error; } public function errorInfo() { return oci_error($this->dbh); } } 