<?php
 namespace Doctrine\DBAL\Schema\Visitor; use Doctrine\DBAL\Platforms\AbstractPlatform; use Doctrine\DBAL\Schema\Table; use Doctrine\DBAL\Schema\ForeignKeyConstraint; use Doctrine\DBAL\Schema\Sequence; use function array_merge; class CreateSchemaSqlCollector extends AbstractVisitor { private $createNamespaceQueries = []; private $createTableQueries = []; private $createSequenceQueries = []; private $createFkConstraintQueries = []; private $platform = null; public function __construct(AbstractPlatform $platform) { $this->platform = $platform; } public function acceptNamespace($namespaceName) { if ($this->platform->supportsSchemas()) { $this->createNamespaceQueries[] = $this->platform->getCreateSchemaSQL($namespaceName); } } public function acceptTable(Table $table) { $this->createTableQueries = array_merge($this->createTableQueries, (array) $this->platform->getCreateTableSQL($table)); } public function acceptForeignKey(Table $localTable, ForeignKeyConstraint $fkConstraint) { if ($this->platform->supportsForeignKeyConstraints()) { $this->createFkConstraintQueries[] = $this->platform->getCreateForeignKeySQL($fkConstraint, $localTable); } } public function acceptSequence(Sequence $sequence) { $this->createSequenceQueries[] = $this->platform->getCreateSequenceSQL($sequence); } public function resetQueries() { $this->createNamespaceQueries = []; $this->createTableQueries = []; $this->createSequenceQueries = []; $this->createFkConstraintQueries = []; } public function getQueries() { return array_merge( $this->createNamespaceQueries, $this->createTableQueries, $this->createSequenceQueries, $this->createFkConstraintQueries ); } } 