<?php
 namespace Doctrine\DBAL\Tools\Console\Command; use Doctrine\DBAL\Driver\PDOStatement; use Symfony\Component\Console\Command\Command; use Symfony\Component\Console\Input\InputArgument; use Symfony\Component\Console\Input\InputInterface; use Symfony\Component\Console\Output\OutputInterface; use const PHP_EOL; use function assert; use function file_exists; use function file_get_contents; use function is_readable; use function realpath; use function sprintf; class ImportCommand extends Command { protected function configure() { $this ->setName('dbal:import') ->setDescription('Import SQL file(s) directly to Database.') ->setDefinition([ new InputArgument( 'file', InputArgument::REQUIRED | InputArgument::IS_ARRAY, 'File path(s) of SQL to be executed.' ) ]) ->setHelp(<<<EOT
Import SQL file(s) directly to Database.
EOT
); } protected function execute(InputInterface $input, OutputInterface $output) { $conn = $this->getHelper('db')->getConnection(); if (($fileNames = $input->getArgument('file')) !== null) { foreach ((array) $fileNames as $fileName) { $filePath = realpath($fileName); if (false === $filePath) { $filePath = $fileName; } if ( ! file_exists($filePath)) { throw new \InvalidArgumentException( sprintf("SQL file '<info>%s</info>' does not exist.", $filePath) ); } elseif ( ! is_readable($filePath)) { throw new \InvalidArgumentException( sprintf("SQL file '<info>%s</info>' does not have read permissions.", $filePath) ); } $output->write(sprintf("Processing file '<info>%s</info>'... ", $filePath)); $sql = file_get_contents($filePath); if ($conn instanceof \Doctrine\DBAL\Driver\PDOConnection) { try { $lines = 0; $stmt = $conn->prepare($sql); assert($stmt instanceof PDOStatement); $stmt->execute(); do { $stmt->fetch(); $stmt->closeCursor(); $lines++; } while ($stmt->nextRowset()); $output->write(sprintf('%d statements executed!', $lines) . PHP_EOL); } catch (\PDOException $e) { $output->write('error!' . PHP_EOL); throw new \RuntimeException($e->getMessage(), $e->getCode(), $e); } } else { $stmt = $conn->prepare($sql); $rs = $stmt->execute(); if ($rs) { $output->writeln('OK!' . PHP_EOL); } else { $error = $stmt->errorInfo(); $output->write('error!' . PHP_EOL); throw new \RuntimeException($error[2], $error[0]); } $stmt->closeCursor(); } } } } } 