<?php
 namespace Doctrine\DBAL\Types; use Doctrine\DBAL\ParameterType; use Doctrine\DBAL\Platforms\AbstractPlatform; use Doctrine\DBAL\DBALException; use function end; use function explode; use function get_class; use function str_replace; abstract class Type { const TARRAY = 'array'; const SIMPLE_ARRAY = 'simple_array'; const JSON_ARRAY = 'json_array'; const JSON = 'json'; const BIGINT = 'bigint'; const BOOLEAN = 'boolean'; const DATETIME = 'datetime'; const DATETIME_IMMUTABLE = 'datetime_immutable'; const DATETIMETZ = 'datetimetz'; const DATETIMETZ_IMMUTABLE = 'datetimetz_immutable'; const DATE = 'date'; const DATE_IMMUTABLE = 'date_immutable'; const TIME = 'time'; const TIME_IMMUTABLE = 'time_immutable'; const DECIMAL = 'decimal'; const INTEGER = 'integer'; const OBJECT = 'object'; const SMALLINT = 'smallint'; const STRING = 'string'; const TEXT = 'text'; const BINARY = 'binary'; const BLOB = 'blob'; const FLOAT = 'float'; const GUID = 'guid'; const DATEINTERVAL = 'dateinterval'; private static $_typeObjects = []; private static $_typesMap = [ self::TARRAY => ArrayType::class, self::SIMPLE_ARRAY => SimpleArrayType::class, self::JSON_ARRAY => JsonArrayType::class, self::JSON => JsonType::class, self::OBJECT => ObjectType::class, self::BOOLEAN => BooleanType::class, self::INTEGER => IntegerType::class, self::SMALLINT => SmallIntType::class, self::BIGINT => BigIntType::class, self::STRING => StringType::class, self::TEXT => TextType::class, self::DATETIME => DateTimeType::class, self::DATETIME_IMMUTABLE => DateTimeImmutableType::class, self::DATETIMETZ => DateTimeTzType::class, self::DATETIMETZ_IMMUTABLE => DateTimeTzImmutableType::class, self::DATE => DateType::class, self::DATE_IMMUTABLE => DateImmutableType::class, self::TIME => TimeType::class, self::TIME_IMMUTABLE => TimeImmutableType::class, self::DECIMAL => DecimalType::class, self::FLOAT => FloatType::class, self::BINARY => BinaryType::class, self::BLOB => BlobType::class, self::GUID => GuidType::class, self::DATEINTERVAL => DateIntervalType::class, ]; final private function __construct() { } public function convertToDatabaseValue($value, AbstractPlatform $platform) { return $value; } public function convertToPHPValue($value, AbstractPlatform $platform) { return $value; } public function getDefaultLength(AbstractPlatform $platform) { return null; } abstract public function getSQLDeclaration(array $fieldDeclaration, AbstractPlatform $platform); abstract public function getName(); public static function getType($name) { if ( ! isset(self::$_typeObjects[$name])) { if ( ! isset(self::$_typesMap[$name])) { throw DBALException::unknownColumnType($name); } self::$_typeObjects[$name] = new self::$_typesMap[$name](); } return self::$_typeObjects[$name]; } public static function addType($name, $className) { if (isset(self::$_typesMap[$name])) { throw DBALException::typeExists($name); } self::$_typesMap[$name] = $className; } public static function hasType($name) { return isset(self::$_typesMap[$name]); } public static function overrideType($name, $className) { if ( ! isset(self::$_typesMap[$name])) { throw DBALException::typeNotFound($name); } if (isset(self::$_typeObjects[$name])) { unset(self::$_typeObjects[$name]); } self::$_typesMap[$name] = $className; } public function getBindingType() { return ParameterType::STRING; } public static function getTypesMap() { return self::$_typesMap; } public function __toString() { $e = explode('\\', get_class($this)); return str_replace('Type', '', end($e)); } public function canRequireSQLConversion() { return false; } public function convertToDatabaseValueSQL($sqlExpr, AbstractPlatform $platform) { return $sqlExpr; } public function convertToPHPValueSQL($sqlExpr, $platform) { return $sqlExpr; } public function getMappedDatabaseTypes(AbstractPlatform $platform) { return []; } public function requiresSQLCommentHint(AbstractPlatform $platform) { return false; } } 