<?php
 namespace Illuminate\Broadcasting\Broadcasters; use Illuminate\Support\Arr; use Illuminate\Support\Str; use Illuminate\Contracts\Redis\Factory as Redis; use Symfony\Component\HttpKernel\Exception\AccessDeniedHttpException; class RedisBroadcaster extends Broadcaster { protected $redis; protected $connection; public function __construct(Redis $redis, $connection = null) { $this->redis = $redis; $this->connection = $connection; } public function auth($request) { if (Str::startsWith($request->channel_name, ['private-', 'presence-']) && ! $request->user()) { throw new AccessDeniedHttpException; } $channelName = Str::startsWith($request->channel_name, 'private-') ? Str::replaceFirst('private-', '', $request->channel_name) : Str::replaceFirst('presence-', '', $request->channel_name); return parent::verifyUserCanAccessChannel( $request, $channelName ); } public function validAuthenticationResponse($request, $result) { if (is_bool($result)) { return json_encode($result); } return json_encode(['channel_data' => [ 'user_id' => $request->user()->getAuthIdentifier(), 'user_info' => $result, ]]); } public function broadcast(array $channels, $event, array $payload = []) { $connection = $this->redis->connection($this->connection); $payload = json_encode([ 'event' => $event, 'data' => $payload, 'socket' => Arr::pull($payload, 'socket'), ]); foreach ($this->formatChannels($channels) as $channel) { $connection->publish($channel, $payload); } } } 