<?php
 namespace Illuminate\Cache\Console; use Illuminate\Console\Command; use Illuminate\Cache\CacheManager; use Illuminate\Filesystem\Filesystem; use Symfony\Component\Console\Input\InputOption; use Symfony\Component\Console\Input\InputArgument; class ClearCommand extends Command { protected $name = 'cache:clear'; protected $description = 'Flush the application cache'; protected $cache; protected $files; public function __construct(CacheManager $cache, Filesystem $files) { parent::__construct(); $this->cache = $cache; $this->files = $files; } public function handle() { $this->laravel['events']->fire( 'cache:clearing', [$this->argument('store'), $this->tags()] ); $this->cache()->flush(); $this->flushFacades(); $this->laravel['events']->fire( 'cache:cleared', [$this->argument('store'), $this->tags()] ); $this->info('Cache cleared successfully.'); } public function flushFacades() { foreach ($this->files->files(storage_path('framework/cache')) as $file) { if (preg_match('/facade-.*\.php$/', $file)) { $this->files->delete($file); } } } protected function cache() { $cache = $this->cache->store($this->argument('store')); return empty($this->tags()) ? $cache : $cache->tags($this->tags()); } protected function tags() { return array_filter(explode(',', $this->option('tags'))); } protected function getArguments() { return [ ['store', InputArgument::OPTIONAL, 'The name of the store you would like to clear.'], ]; } protected function getOptions() { return [ ['tags', null, InputOption::VALUE_OPTIONAL, 'The cache tags you would like to clear.', null], ]; } } 