<?php
 namespace Illuminate\Config; use ArrayAccess; use Illuminate\Support\Arr; use Illuminate\Contracts\Config\Repository as ConfigContract; class Repository implements ArrayAccess, ConfigContract { protected $items = []; public function __construct(array $items = []) { $this->items = $items; } public function has($key) { return Arr::has($this->items, $key); } public function get($key, $default = null) { if (is_array($key)) { return $this->getMany($key); } return Arr::get($this->items, $key, $default); } public function getMany($keys) { $config = []; foreach ($keys as $key => $default) { if (is_numeric($key)) { list($key, $default) = [$default, null]; } $config[$key] = Arr::get($this->items, $key, $default); } return $config; } public function set($key, $value = null) { $keys = is_array($key) ? $key : [$key => $value]; foreach ($keys as $key => $value) { Arr::set($this->items, $key, $value); } } public function prepend($key, $value) { $array = $this->get($key); array_unshift($array, $value); $this->set($key, $array); } public function push($key, $value) { $array = $this->get($key); $array[] = $value; $this->set($key, $array); } public function all() { return $this->items; } public function offsetExists($key) { return $this->has($key); } public function offsetGet($key) { return $this->get($key); } public function offsetSet($key, $value) { $this->set($key, $value); } public function offsetUnset($key) { $this->set($key, null); } } 