<?php
 namespace Illuminate\Console; use Illuminate\Support\Str; use Illuminate\Filesystem\Filesystem; use Symfony\Component\Console\Input\InputArgument; abstract class GeneratorCommand extends Command { protected $files; protected $type; public function __construct(Filesystem $files) { parent::__construct(); $this->files = $files; } abstract protected function getStub(); public function handle() { $name = $this->qualifyClass($this->getNameInput()); $path = $this->getPath($name); if ((! $this->hasOption('force') || ! $this->option('force')) && $this->alreadyExists($this->getNameInput())) { $this->error($this->type.' already exists!'); return false; } $this->makeDirectory($path); $this->files->put($path, $this->buildClass($name)); $this->info($this->type.' created successfully.'); } protected function qualifyClass($name) { $name = ltrim($name, '\\/'); $rootNamespace = $this->rootNamespace(); if (Str::startsWith($name, $rootNamespace)) { return $name; } $name = str_replace('/', '\\', $name); return $this->qualifyClass( $this->getDefaultNamespace(trim($rootNamespace, '\\')).'\\'.$name ); } protected function getDefaultNamespace($rootNamespace) { return $rootNamespace; } protected function alreadyExists($rawName) { return $this->files->exists($this->getPath($this->qualifyClass($rawName))); } protected function getPath($name) { $name = Str::replaceFirst($this->rootNamespace(), '', $name); return $this->laravel['path'].'/'.str_replace('\\', '/', $name).'.php'; } protected function makeDirectory($path) { if (! $this->files->isDirectory(dirname($path))) { $this->files->makeDirectory(dirname($path), 0777, true, true); } return $path; } protected function buildClass($name) { $stub = $this->files->get($this->getStub()); return $this->replaceNamespace($stub, $name)->replaceClass($stub, $name); } protected function replaceNamespace(&$stub, $name) { $stub = str_replace( ['DummyNamespace', 'DummyRootNamespace', 'NamespacedDummyUserModel'], [$this->getNamespace($name), $this->rootNamespace(), config('auth.providers.users.model')], $stub ); return $this; } protected function getNamespace($name) { return trim(implode('\\', array_slice(explode('\\', $name), 0, -1)), '\\'); } protected function replaceClass($stub, $name) { $class = str_replace($this->getNamespace($name).'\\', '', $name); return str_replace('DummyClass', $class, $stub); } protected function getNameInput() { return trim($this->argument('name')); } protected function rootNamespace() { return $this->laravel->getNamespace(); } protected function getArguments() { return [ ['name', InputArgument::REQUIRED, 'The name of the class'], ]; } } 