<?php
 namespace Illuminate\Foundation\Auth; use Illuminate\Support\Str; use Illuminate\Http\Request; use Illuminate\Support\Facades\Auth; use Illuminate\Support\Facades\Hash; use Illuminate\Support\Facades\Password; use Illuminate\Auth\Events\PasswordReset; trait ResetsPasswords { use RedirectsUsers; public function showResetForm(Request $request, $token = null) { return view('auth.passwords.reset')->with( ['token' => $token, 'email' => $request->email] ); } public function reset(Request $request) { $this->validate($request, $this->rules(), $this->validationErrorMessages()); $response = $this->broker()->reset( $this->credentials($request), function ($user, $password) { $this->resetPassword($user, $password); } ); return $response == Password::PASSWORD_RESET ? $this->sendResetResponse($response) : $this->sendResetFailedResponse($request, $response); } protected function rules() { return [ 'token' => 'required', 'email' => 'required|email', 'password' => 'required|confirmed|min:6', ]; } protected function validationErrorMessages() { return []; } protected function credentials(Request $request) { return $request->only( 'email', 'password', 'password_confirmation', 'token' ); } protected function resetPassword($user, $password) { $user->password = Hash::make($password); $user->setRememberToken(Str::random(60)); $user->save(); event(new PasswordReset($user)); $this->guard()->login($user); } protected function sendResetResponse($response) { return redirect($this->redirectPath()) ->with('status', trans($response)); } protected function sendResetFailedResponse(Request $request, $response) { return redirect()->back() ->withInput($request->only('email')) ->withErrors(['email' => trans($response)]); } public function broker() { return Password::broker(); } protected function guard() { return Auth::guard(); } } 