<?php
 namespace Illuminate\Foundation\Auth; use Illuminate\Support\Str; use Illuminate\Http\Request; use Illuminate\Cache\RateLimiter; use Illuminate\Auth\Events\Lockout; use Illuminate\Support\Facades\Lang; use Illuminate\Validation\ValidationException; trait ThrottlesLogins { protected function hasTooManyLoginAttempts(Request $request) { return $this->limiter()->tooManyAttempts( $this->throttleKey($request), $this->maxAttempts(), $this->decayMinutes() ); } protected function incrementLoginAttempts(Request $request) { $this->limiter()->hit( $this->throttleKey($request), $this->decayMinutes() ); } protected function sendLockoutResponse(Request $request) { $seconds = $this->limiter()->availableIn( $this->throttleKey($request) ); throw ValidationException::withMessages([ $this->username() => [Lang::get('auth.throttle', ['seconds' => $seconds])], ])->status(423); } protected function clearLoginAttempts(Request $request) { $this->limiter()->clear($this->throttleKey($request)); } protected function fireLockoutEvent(Request $request) { event(new Lockout($request)); } protected function throttleKey(Request $request) { return Str::lower($request->input($this->username())).'|'.$request->ip(); } protected function limiter() { return app(RateLimiter::class); } public function maxAttempts() { return property_exists($this, 'maxAttempts') ? $this->maxAttempts : 5; } public function decayMinutes() { return property_exists($this, 'decayMinutes') ? $this->decayMinutes : 1; } } 