<?php
 namespace Illuminate\Foundation\Console; use Illuminate\Support\Str; use Illuminate\Console\GeneratorCommand; use Symfony\Component\Console\Input\InputOption; class PolicyMakeCommand extends GeneratorCommand { protected $name = 'make:policy'; protected $description = 'Create a new policy class'; protected $type = 'Policy'; protected function buildClass($name) { $stub = $this->replaceUserNamespace( parent::buildClass($name) ); $model = $this->option('model'); return $model ? $this->replaceModel($stub, $model) : $stub; } protected function replaceUserNamespace($stub) { if (! config('auth.providers.users.model')) { return $stub; } return str_replace( $this->rootNamespace().'User', config('auth.providers.users.model'), $stub ); } protected function replaceModel($stub, $model) { $model = str_replace('/', '\\', $model); $namespaceModel = $this->laravel->getNamespace().$model; if (Str::startsWith($model, '\\')) { $stub = str_replace('NamespacedDummyModel', trim($model, '\\'), $stub); } else { $stub = str_replace('NamespacedDummyModel', $namespaceModel, $stub); } $stub = str_replace( "use {$namespaceModel};\nuse {$namespaceModel};", "use {$namespaceModel};", $stub ); $model = class_basename(trim($model, '\\')); $dummyUser = class_basename(config('auth.providers.users.model')); $dummyModel = Str::camel($model) === 'user' ? 'model' : Str::camel($model); $stub = str_replace('DummyModel', $model, $stub); $stub = str_replace('dummyModel', $dummyModel, $stub); $stub = str_replace('DummyUser', $dummyUser, $stub); return str_replace('dummyPluralModel', Str::plural($dummyModel), $stub); } protected function getStub() { return $this->option('model') ? __DIR__.'/stubs/policy.stub' : __DIR__.'/stubs/policy.plain.stub'; } protected function getDefaultNamespace($rootNamespace) { return $rootNamespace.'\Policies'; } protected function getOptions() { return [ ['model', 'm', InputOption::VALUE_OPTIONAL, 'The model that the policy applies to.'], ]; } } 