<?php
 namespace Illuminate\Queue; use Aws\Sqs\SqsClient; use Illuminate\Queue\Jobs\SqsJob; use Illuminate\Contracts\Queue\Queue as QueueContract; class SqsQueue extends Queue implements QueueContract { protected $sqs; protected $default; protected $prefix; public function __construct(SqsClient $sqs, $default, $prefix = '') { $this->sqs = $sqs; $this->prefix = $prefix; $this->default = $default; } public function size($queue = null) { $response = $this->sqs->getQueueAttributes([ 'QueueUrl' => $this->getQueue($queue), 'AttributeNames' => ['ApproximateNumberOfMessages'], ]); $attributes = $response->get('Attributes'); return (int) $attributes['ApproximateNumberOfMessages']; } public function push($job, $data = '', $queue = null) { return $this->pushRaw($this->createPayload($job, $data), $queue); } public function pushRaw($payload, $queue = null, array $options = []) { return $this->sqs->sendMessage([ 'QueueUrl' => $this->getQueue($queue), 'MessageBody' => $payload, ])->get('MessageId'); } public function later($delay, $job, $data = '', $queue = null) { return $this->sqs->sendMessage([ 'QueueUrl' => $this->getQueue($queue), 'MessageBody' => $this->createPayload($job, $data), 'DelaySeconds' => $this->secondsUntil($delay), ])->get('MessageId'); } public function pop($queue = null) { $response = $this->sqs->receiveMessage([ 'QueueUrl' => $queue = $this->getQueue($queue), 'AttributeNames' => ['ApproximateReceiveCount'], ]); if (! is_null($response['Messages']) && count($response['Messages']) > 0) { return new SqsJob( $this->container, $this->sqs, $response['Messages'][0], $this->connectionName, $queue ); } } public function getQueue($queue) { $queue = $queue ?: $this->default; return filter_var($queue, FILTER_VALIDATE_URL) === false ? rtrim($this->prefix, '/').'/'.$queue : $queue; } public function getSqs() { return $this->sqs; } } 