<?php
 namespace Illuminate\Support\Facades; use Mockery; use RuntimeException; use Mockery\MockInterface; abstract class Facade { protected static $app; protected static $resolvedInstance; public static function spy() { if (! static::isMock()) { $class = static::getMockableClass(); static::swap($class ? Mockery::spy($class) : Mockery::spy()); } } public static function shouldReceive() { $name = static::getFacadeAccessor(); $mock = static::isMock() ? static::$resolvedInstance[$name] : static::createFreshMockInstance(); return $mock->shouldReceive(...func_get_args()); } protected static function createFreshMockInstance() { return tap(static::createMock(), function ($mock) { static::swap($mock); $mock->shouldAllowMockingProtectedMethods(); }); } protected static function createMock() { $class = static::getMockableClass(); return $class ? Mockery::mock($class) : Mockery::mock(); } protected static function isMock() { $name = static::getFacadeAccessor(); return isset(static::$resolvedInstance[$name]) && static::$resolvedInstance[$name] instanceof MockInterface; } protected static function getMockableClass() { if ($root = static::getFacadeRoot()) { return get_class($root); } } public static function swap($instance) { static::$resolvedInstance[static::getFacadeAccessor()] = $instance; if (isset(static::$app)) { static::$app->instance(static::getFacadeAccessor(), $instance); } } public static function getFacadeRoot() { return static::resolveFacadeInstance(static::getFacadeAccessor()); } protected static function getFacadeAccessor() { throw new RuntimeException('Facade does not implement getFacadeAccessor method.'); } protected static function resolveFacadeInstance($name) { if (is_object($name)) { return $name; } if (isset(static::$resolvedInstance[$name])) { return static::$resolvedInstance[$name]; } return static::$resolvedInstance[$name] = static::$app[$name]; } public static function clearResolvedInstance($name) { unset(static::$resolvedInstance[$name]); } public static function clearResolvedInstances() { static::$resolvedInstance = []; } public static function getFacadeApplication() { return static::$app; } public static function setFacadeApplication($app) { static::$app = $app; } public static function __callStatic($method, $args) { $instance = static::getFacadeRoot(); if (! $instance) { throw new RuntimeException('A facade root has not been set.'); } return $instance->$method(...$args); } } 