<?php
 namespace Illuminate\Support\Testing\Fakes; use Illuminate\Contracts\Mail\Mailer; use Illuminate\Contracts\Mail\Mailable; use PHPUnit\Framework\Assert as PHPUnit; use Illuminate\Contracts\Queue\ShouldQueue; class MailFake implements Mailer { protected $mailables = []; protected $queuedMailables = []; public function assertSent($mailable, $callback = null) { if (is_numeric($callback)) { return $this->assertSentTimes($mailable, $callback); } PHPUnit::assertTrue( $this->sent($mailable, $callback)->count() > 0, "The expected [{$mailable}] mailable was not sent." ); } protected function assertSentTimes($mailable, $times = 1) { PHPUnit::assertTrue( ($count = $this->sent($mailable)->count()) === $times, "The expected [{$mailable}] mailable was sent {$count} times instead of {$times} times." ); } public function assertNotSent($mailable, $callback = null) { PHPUnit::assertTrue( $this->sent($mailable, $callback)->count() === 0, "The unexpected [{$mailable}] mailable was sent." ); } public function assertNothingSent() { PHPUnit::assertEmpty($this->mailables, 'Mailables were sent unexpectedly.'); } public function assertQueued($mailable, $callback = null) { if (is_numeric($callback)) { return $this->assertQueuedTimes($mailable, $callback); } PHPUnit::assertTrue( $this->queued($mailable, $callback)->count() > 0, "The expected [{$mailable}] mailable was not queued." ); } protected function assertQueuedTimes($mailable, $times = 1) { PHPUnit::assertTrue( ($count = $this->queued($mailable)->count()) === $times, "The expected [{$mailable}] mailable was queued {$count} times instead of {$times} times." ); } public function assertNotQueued($mailable, $callback = null) { PHPUnit::assertTrue( $this->queued($mailable, $callback)->count() === 0, "The unexpected [{$mailable}] mailable was queued." ); } public function assertNothingQueued() { PHPUnit::assertEmpty($this->queuedMailables, 'Mailables were queued unexpectedly.'); } public function sent($mailable, $callback = null) { if (! $this->hasSent($mailable)) { return collect(); } $callback = $callback ?: function () { return true; }; return $this->mailablesOf($mailable)->filter(function ($mailable) use ($callback) { return $callback($mailable); }); } public function hasSent($mailable) { return $this->mailablesOf($mailable)->count() > 0; } public function queued($mailable, $callback = null) { if (! $this->hasQueued($mailable)) { return collect(); } $callback = $callback ?: function () { return true; }; return $this->queuedMailablesOf($mailable)->filter(function ($mailable) use ($callback) { return $callback($mailable); }); } public function hasQueued($mailable) { return $this->queuedMailablesOf($mailable)->count() > 0; } protected function mailablesOf($type) { return collect($this->mailables)->filter(function ($mailable) use ($type) { return $mailable instanceof $type; }); } protected function queuedMailablesOf($type) { return collect($this->queuedMailables)->filter(function ($mailable) use ($type) { return $mailable instanceof $type; }); } public function to($users) { return (new PendingMailFake($this))->to($users); } public function bcc($users) { return (new PendingMailFake($this))->bcc($users); } public function raw($text, $callback) { } public function send($view, array $data = [], $callback = null) { if (! $view instanceof Mailable) { return; } if ($view instanceof ShouldQueue) { return $this->queue($view, $data, $callback); } $this->mailables[] = $view; } public function queue($view, $queue = null) { if (! $view instanceof Mailable) { return; } $this->queuedMailables[] = $view; } public function failures() { } } 