<?php
 namespace Naux\Mail; use GuzzleHttp\Client; use Illuminate\Mail\Transport\Transport; use Psr\Http\Message\ResponseInterface; use Swift_Mime_SimpleMessage; class SendCloudTransport extends Transport { const SEND_HTML_URL = 'http://sendcloud.sohu.com/webapi/mail.send.json'; const SEND_TEMPLATE_URL = 'http://sendcloud.sohu.com/webapi/mail.send_template.json'; protected $query = []; private $api_user; private $api_key; public function __construct($api_user, $api_key) { $this->api_user = $api_user; $this->api_key = $api_key; } public function send(Swift_Mime_SimpleMessage $message, &$failedRecipients = null) { $this->addQuery('api_user', $this->api_user); $this->addQuery('api_key', $this->api_key); $this->addQuery('subject', $message->getSubject()); $this->addQuery('from', $this->getAddress($message->getFrom())); $this->addQuery('fromname', $this->getFromName($message)); $this->addQuery('replyto', $this->getAddress($message->getReplyTo())); $this->addQuery('cc', $this->getAddresses($message->getCc())); $this->addQuery('bcc', $this->getAddresses($message->getBCc())); if (!empty($message->getChildren())) { foreach ($message->getChildren() as $file) { if ($file instanceof \Swift_MimePart) { continue; } $this->addQuery('files[]', $file->getBody(), $file->getFilename()); } } $this->query = array_filter($this->query); $body = $message->getBody(); if ($body instanceof SendCloudTemplate) { $result = $this->sendTemplate($message); } else { $result = $this->sendRawMessage($message); } $this->query = []; return $result; } protected function getAddress($data) { if (!$data) { return; } return array_get(array_keys($data), 0, null); } protected function getFromName(Swift_Mime_SimpleMessage $message) { return array_get(array_values($message->getFrom()), 0); } protected function getAddresses($data) { if (!$data || !is_array($data)) { return null; } $data = array_keys($data); if (empty($data)) { return null; } return implode(';', $data); } protected function sendRawMessage(Swift_Mime_SimpleMessage $message) { $http = new Client(); $this->addQuery('html', $message->getBody() ?: ''); $this->addQuery('to', $this->getAddress($message->getTo())); $response = $http->post(self::SEND_HTML_URL, [ 'multipart' => $this->query, ]); return $this->response($response); } protected function sendTemplate(Swift_Mime_SimpleMessage $message) { $http = new Client(); $template = $message->getBody(); $this->addQuery('template_invoke_name', $template->getName()); $this->addQuery('substitution_vars', json_encode([ 'to' => [$this->getAddress($message->getTo())], 'sub' => $template->getBindData(), ])); $response = $http->post(self::SEND_TEMPLATE_URL, [ 'multipart' => $this->query, ]); return $this->response($response); } protected function response(ResponseInterface $response) { $res = json_decode($response->getBody()->getContents()); if (isset($res->errors)) { throw new SendCloudException(array_get($res->errors, 0)); } return true; } public function addQuery($name, $contents, $filename = null) { $query = [ 'name' => $name, 'contents' => $contents, ]; if ($filename) { $query['filename'] = $filename; } $this->query[] = $query; } } 