<?php declare(strict_types=1); namespace PhpParser\Node\Stmt; use PHPUnit\Framework\TestCase; class ClassTest extends TestCase { public function testIsAbstract() { $class = new Class_('Foo', ['type' => Class_::MODIFIER_ABSTRACT]); $this->assertTrue($class->isAbstract()); $class = new Class_('Foo'); $this->assertFalse($class->isAbstract()); } public function testIsFinal() { $class = new Class_('Foo', ['type' => Class_::MODIFIER_FINAL]); $this->assertTrue($class->isFinal()); $class = new Class_('Foo'); $this->assertFalse($class->isFinal()); } public function testGetMethods() { $methods = [ new ClassMethod('foo'), new ClassMethod('bar'), new ClassMethod('fooBar'), ]; $class = new Class_('Foo', [ 'stmts' => [ new TraitUse([]), $methods[0], new ClassConst([]), $methods[1], new Property(0, []), $methods[2], ] ]); $this->assertSame($methods, $class->getMethods()); } public function testGetMethod() { $methodConstruct = new ClassMethod('__CONSTRUCT'); $methodTest = new ClassMethod('test'); $class = new Class_('Foo', [ 'stmts' => [ new ClassConst([]), $methodConstruct, new Property(0, []), $methodTest, ] ]); $this->assertSame($methodConstruct, $class->getMethod('__construct')); $this->assertSame($methodTest, $class->getMethod('test')); $this->assertNull($class->getMethod('nonExisting')); } } 