<?php
 namespace Symfony\Component\HttpFoundation\Session\Storage\Handler; class MongoDbSessionHandler extends AbstractSessionHandler { private $mongo; private $collection; private $options; public function __construct($mongo, array $options) { if ($mongo instanceof \MongoClient || $mongo instanceof \Mongo) { @trigger_error(sprintf('Using %s with the legacy mongo extension is deprecated as of 3.4 and will be removed in 4.0. Use it with the mongodb/mongodb package and ext-mongodb instead.', __CLASS__), E_USER_DEPRECATED); } if (!($mongo instanceof \MongoDB\Client || $mongo instanceof \MongoClient || $mongo instanceof \Mongo)) { throw new \InvalidArgumentException('MongoClient or Mongo instance required'); } if (!isset($options['database']) || !isset($options['collection'])) { throw new \InvalidArgumentException('You must provide the "database" and "collection" option for MongoDBSessionHandler'); } $this->mongo = $mongo; $this->options = array_merge(array( 'id_field' => '_id', 'data_field' => 'data', 'time_field' => 'time', 'expiry_field' => 'expires_at', ), $options); } public function close() { return true; } protected function doDestroy($sessionId) { $methodName = $this->mongo instanceof \MongoDB\Client ? 'deleteOne' : 'remove'; $this->getCollection()->$methodName(array( $this->options['id_field'] => $sessionId, )); return true; } public function gc($maxlifetime) { $methodName = $this->mongo instanceof \MongoDB\Client ? 'deleteMany' : 'remove'; $this->getCollection()->$methodName(array( $this->options['expiry_field'] => array('$lt' => $this->createDateTime()), )); return true; } protected function doWrite($sessionId, $data) { $expiry = $this->createDateTime(time() + (int) ini_get('session.gc_maxlifetime')); $fields = array( $this->options['time_field'] => $this->createDateTime(), $this->options['expiry_field'] => $expiry, ); $options = array('upsert' => true); if ($this->mongo instanceof \MongoDB\Client) { $fields[$this->options['data_field']] = new \MongoDB\BSON\Binary($data, \MongoDB\BSON\Binary::TYPE_OLD_BINARY); } else { $fields[$this->options['data_field']] = new \MongoBinData($data, \MongoBinData::BYTE_ARRAY); $options['multiple'] = false; } $methodName = $this->mongo instanceof \MongoDB\Client ? 'updateOne' : 'update'; $this->getCollection()->$methodName( array($this->options['id_field'] => $sessionId), array('$set' => $fields), $options ); return true; } public function updateTimestamp($sessionId, $data) { $expiry = $this->createDateTime(time() + (int) ini_get('session.gc_maxlifetime')); if ($this->mongo instanceof \MongoDB\Client) { $methodName = 'updateOne'; $options = array(); } else { $methodName = 'update'; $options = array('multiple' => false); } $this->getCollection()->$methodName( array($this->options['id_field'] => $sessionId), array('$set' => array( $this->options['time_field'] => $this->createDateTime(), $this->options['expiry_field'] => $expiry, )), $options ); return true; } protected function doRead($sessionId) { $dbData = $this->getCollection()->findOne(array( $this->options['id_field'] => $sessionId, $this->options['expiry_field'] => array('$gte' => $this->createDateTime()), )); if (null === $dbData) { return ''; } if ($dbData[$this->options['data_field']] instanceof \MongoDB\BSON\Binary) { return $dbData[$this->options['data_field']]->getData(); } return $dbData[$this->options['data_field']]->bin; } private function getCollection() { if (null === $this->collection) { $this->collection = $this->mongo->selectCollection($this->options['database'], $this->options['collection']); } return $this->collection; } protected function getMongo() { return $this->mongo; } private function createDateTime($seconds = null) { if (null === $seconds) { $seconds = time(); } if ($this->mongo instanceof \MongoDB\Client) { return new \MongoDB\BSON\UTCDateTime($seconds * 1000); } return new \MongoDate($seconds); } } 