<?php
 namespace TijsVerkoyen\CssToInlineStyles; use Symfony\Component\CssSelector\CssSelector; use Symfony\Component\CssSelector\CssSelectorConverter; use Symfony\Component\CssSelector\Exception\ExceptionInterface; use TijsVerkoyen\CssToInlineStyles\Css\Processor; use TijsVerkoyen\CssToInlineStyles\Css\Property\Processor as PropertyProcessor; use TijsVerkoyen\CssToInlineStyles\Css\Rule\Processor as RuleProcessor; use TijsVerkoyen\CssToInlineStyles\Css\Rule\Rule; class CssToInlineStyles { private $cssConverter; public function __construct() { if (class_exists('Symfony\Component\CssSelector\CssSelectorConverter')) { $this->cssConverter = new CssSelectorConverter(); } } public function convert($html, $css = null) { $document = $this->createDomDocumentFromHtml($html); $processor = new Processor(); $rules = $processor->getRules( $processor->getCssFromStyleTags($html) ); if ($css !== null) { $rules = $processor->getRules($css, $rules); } $document = $this->inline($document, $rules); return $this->getHtmlFromDocument($document); } public function inlineCssOnElement(\DOMElement $element, array $properties) { if (empty($properties)) { return $element; } $cssProperties = array(); $inlineProperties = array(); foreach ($this->getInlineStyles($element) as $property) { $inlineProperties[$property->getName()] = $property; } foreach ($properties as $property) { if (!isset($inlineProperties[$property->getName()])) { $cssProperties[$property->getName()] = $property; } } $rules = array(); foreach (array_merge($cssProperties, $inlineProperties) as $property) { $rules[] = $property->toString(); } $element->setAttribute('style', implode(' ', $rules)); return $element; } public function getInlineStyles(\DOMElement $element) { $processor = new PropertyProcessor(); return $processor->convertArrayToObjects( $processor->splitIntoSeparateProperties( $element->getAttribute('style') ) ); } protected function createDomDocumentFromHtml($html) { $document = new \DOMDocument('1.0', 'UTF-8'); $internalErrors = libxml_use_internal_errors(true); $document->loadHTML(mb_convert_encoding($html, 'HTML-ENTITIES', 'UTF-8')); libxml_use_internal_errors($internalErrors); $document->formatOutput = true; return $document; } protected function getHtmlFromDocument(\DOMDocument $document) { $htmlElement = $document->documentElement; $html = $document->saveHTML($htmlElement); $html = trim($html); $document->removeChild($htmlElement); $doctype = $document->saveHTML(); $doctype = trim($doctype); if ($doctype === '<!DOCTYPE html>') { $doctype = strtolower($doctype); } return $doctype."\n".$html; } protected function inline(\DOMDocument $document, array $rules) { if (empty($rules)) { return $document; } $propertyStorage = new \SplObjectStorage(); $xPath = new \DOMXPath($document); usort($rules, array(RuleProcessor::class, 'sortOnSpecificity')); foreach ($rules as $rule) { try { if (null !== $this->cssConverter) { $expression = $this->cssConverter->toXPath($rule->getSelector()); } else { $expression = CssSelector::toXPath($rule->getSelector()); } } catch (ExceptionInterface $e) { continue; } $elements = $xPath->query($expression); if ($elements === false) { continue; } foreach ($elements as $element) { $propertyStorage[$element] = $this->calculatePropertiesToBeApplied( $rule->getProperties(), $propertyStorage->contains($element) ? $propertyStorage[$element] : array() ); } } foreach ($propertyStorage as $element) { $this->inlineCssOnElement($element, $propertyStorage[$element]); } return $document; } private function calculatePropertiesToBeApplied(array $properties, array $cssProperties) { if (empty($properties)) { return $cssProperties; } foreach ($properties as $property) { if (isset($cssProperties[$property->getName()])) { $existingProperty = $cssProperties[$property->getName()]; if ($existingProperty->isImportant() && !$property->isImportant()) { continue; } $overrule = !$existingProperty->isImportant() && $property->isImportant(); if (!$overrule) { $overrule = $existingProperty->getOriginalSpecificity()->compareTo($property->getOriginalSpecificity()) <= 0; } if ($overrule) { unset($cssProperties[$property->getName()]); $cssProperties[$property->getName()] = $property; } } else { $cssProperties[$property->getName()] = $property; } } return $cssProperties; } } 