<?php
 namespace Dotenv; use Dotenv\Exception\InvalidCallbackException; use Dotenv\Exception\ValidationException; class Validator { protected $variables; protected $loader; public function __construct(array $variables, Loader $loader) { $this->variables = $variables; $this->loader = $loader; $this->assertCallback( function ($value) { return $value !== null; }, 'is missing' ); } public function notEmpty() { return $this->assertCallback( function ($value) { return strlen(trim($value)) > 0; }, 'is empty' ); } public function isInteger() { return $this->assertCallback( function ($value) { return ctype_digit($value); }, 'is not an integer' ); } public function isBoolean() { return $this->assertCallback( function ($value) { if ($value === '') { return false; } return (filter_var($value, FILTER_VALIDATE_BOOLEAN, FILTER_NULL_ON_FAILURE) !== NULL); }, 'is not a boolean' ); } public function allowedValues(array $choices) { return $this->assertCallback( function ($value) use ($choices) { return in_array($value, $choices); }, 'is not an allowed value' ); } protected function assertCallback($callback, $message = 'failed callback assertion') { if (!is_callable($callback)) { throw new InvalidCallbackException('The provided callback must be callable.'); } $variablesFailingAssertion = array(); foreach ($this->variables as $variableName) { $variableValue = $this->loader->getEnvironmentVariable($variableName); if (call_user_func($callback, $variableValue) === false) { $variablesFailingAssertion[] = $variableName." $message"; } } if (count($variablesFailingAssertion) > 0) { throw new ValidationException(sprintf( 'One or more environment variables failed assertions: %s.', implode(', ', $variablesFailingAssertion) )); } return $this; } } 