<?php
 declare(strict_types=1); namespace voku\helper; final class AntiXSS { private static $entitiesFallback = [ "\t" => '&Tab;', "\n" => '&NewLine;', '!' => '&excl;', '"' => '&quot;', '#' => '&num;', '$' => '&dollar;', '%' => '&percnt;', '&' => '&amp;', "'" => '&apos;', '(' => '&lpar;', ')' => '&rpar;', '*' => '&ast;', '+' => '&plus;', ',' => '&comma;', '.' => '&period;', '/' => '&sol;', ':' => '&colon;', ';' => '&semi;', '<' => '&lt;', '<⃒' => '&nvlt;', '=' => '&equals;', '=⃥' => '&bne;', '>' => '&gt;', '>⃒' => '&nvgt', '?' => '&quest;', '@' => '&commat;', '[' => '&lbrack;', ']' => '&rsqb;', '^' => '&Hat;', '_' => '&lowbar;', '`' => '&grave;', 'fj' => '&fjlig;', '{' => '&lbrace;', '|' => '&vert;', '}' => '&rcub;', ' ' => '&nbsp;', '¡' => '&iexcl;', '¢' => '&cent;', '£' => '&pound;', '¤' => '&curren;', '¥' => '&yen;', '¦' => '&brvbar;', '§' => '&sect;', '¨' => '&DoubleDot;', '©' => '&copy;', 'ª' => '&ordf;', '«' => '&laquo;', '¬' => '&not;', '­' => '&shy;', '®' => '&reg;', '¯' => '&macr;', '°' => '&deg;', '±' => '&plusmn;', '²' => '&sup2;', '³' => '&sup3;', '´' => '&DiacriticalAcute;', 'µ' => '&micro;', '¶' => '&para;', '·' => '&CenterDot;', '¸' => '&Cedilla;', '¹' => '&sup1;', 'º' => '&ordm;', '»' => '&raquo;', '¼' => '&frac14;', '½' => '&half;', '¾' => '&frac34;', '¿' => '&iquest;', 'À' => '&Agrave;', 'Á' => '&Aacute;', 'Â' => '&Acirc;', 'Ã' => '&Atilde;', 'Ä' => '&Auml;', 'Å' => '&Aring;', 'Æ' => '&AElig;', 'Ç' => '&Ccedil;', 'È' => '&Egrave;', 'É' => '&Eacute;', 'Ê' => '&Ecirc;', 'Ë' => '&Euml;', 'Ì' => '&Igrave;', 'Í' => '&Iacute;', 'Î' => '&Icirc;', 'Ï' => '&Iuml;', 'Ð' => '&ETH;', 'Ñ' => '&Ntilde;', 'Ò' => '&Ograve;', 'Ó' => '&Oacute;', 'Ô' => '&Ocirc;', 'Õ' => '&Otilde;', 'Ö' => '&Ouml;', '×' => '&times;', 'Ø' => '&Oslash;', 'Ù' => '&Ugrave;', 'Ú' => '&Uacute;', 'Û' => '&Ucirc;', 'Ü' => '&Uuml;', 'Ý' => '&Yacute;', 'Þ' => '&THORN;', 'ß' => '&szlig;', 'à' => '&agrave;', 'á' => '&aacute;', 'â' => '&acirc;', 'ã' => '&atilde;', 'ä' => '&auml;', 'å' => '&aring;', 'æ' => '&aelig;', 'ç' => '&ccedil;', 'è' => '&egrave;', 'é' => '&eacute;', 'ê' => '&ecirc;', 'ë' => '&euml;', 'ì' => '&igrave;', 'í' => '&iacute;', 'î' => '&icirc;', 'ï' => '&iuml;', 'ð' => '&eth;', 'ñ' => '&ntilde;', 'ò' => '&ograve;', 'ó' => '&oacute;', 'ô' => '&ocirc;', 'õ' => '&otilde;', 'ö' => '&ouml;', '÷' => '&divide;', 'ø' => '&oslash;', 'ù' => '&ugrave;', 'ú' => '&uacute;', 'û' => '&ucirc;', 'ü' => '&uuml;', 'ý' => '&yacute;', 'þ' => '&thorn;', 'ÿ' => '&yuml;', 'Ā' => '&Amacr;', 'ā' => '&amacr;', 'Ă' => '&Abreve;', 'ă' => '&abreve;', 'Ą' => '&Aogon;', 'ą' => '&aogon;', 'Ć' => '&Cacute;', 'ć' => '&cacute;', 'Ĉ' => '&Ccirc;', 'ĉ' => '&ccirc;', 'Ċ' => '&Cdot;', 'ċ' => '&cdot;', 'Č' => '&Ccaron;', 'č' => '&ccaron;', 'Ď' => '&Dcaron;', 'ď' => '&dcaron;', 'Đ' => '&Dstrok;', 'đ' => '&dstrok;', 'Ē' => '&Emacr;', 'ē' => '&emacr;', 'Ė' => '&Edot;', 'ė' => '&edot;', 'Ę' => '&Eogon;', 'ę' => '&eogon;', 'Ě' => '&Ecaron;', 'ě' => '&ecaron;', 'Ĝ' => '&Gcirc;', 'ĝ' => '&gcirc;', 'Ğ' => '&Gbreve;', 'ğ' => '&gbreve;', 'Ġ' => '&Gdot;', 'ġ' => '&gdot;', 'Ģ' => '&Gcedil;', 'Ĥ' => '&Hcirc;', 'ĥ' => '&hcirc;', 'Ħ' => '&Hstrok;', 'ħ' => '&hstrok;', 'Ĩ' => '&Itilde;', 'ĩ' => '&itilde;', 'Ī' => '&Imacr;', 'ī' => '&imacr;', 'Į' => '&Iogon;', 'į' => '&iogon;', 'İ' => '&Idot;', 'ı' => '&inodot;', 'Ĳ' => '&IJlig;', 'ĳ' => '&ijlig;', 'Ĵ' => '&Jcirc;', 'ĵ' => '&jcirc;', 'Ķ' => '&Kcedil;', 'ķ' => '&kcedil;', 'ĸ' => '&kgreen;', 'Ĺ' => '&Lacute;', 'ĺ' => '&lacute;', 'Ļ' => '&Lcedil;', 'ļ' => '&lcedil;', 'Ľ' => '&Lcaron;', 'ľ' => '&lcaron;', 'Ŀ' => '&Lmidot;', 'ŀ' => '&lmidot;', 'Ł' => '&Lstrok;', 'ł' => '&lstrok;', 'Ń' => '&Nacute;', 'ń' => '&nacute;', 'Ņ' => '&Ncedil;', 'ņ' => '&ncedil;', 'Ň' => '&Ncaron;', 'ň' => '&ncaron;', 'ŉ' => '&napos;', 'Ŋ' => '&ENG;', 'ŋ' => '&eng;', 'Ō' => '&Omacr;', 'ō' => '&omacr;', 'Ő' => '&Odblac;', 'ő' => '&odblac;', 'Œ' => '&OElig;', 'œ' => '&oelig;', 'Ŕ' => '&Racute;', 'ŕ' => '&racute;', 'Ŗ' => '&Rcedil;', 'ŗ' => '&rcedil;', 'Ř' => '&Rcaron;', 'ř' => '&rcaron;', 'Ś' => '&Sacute;', 'ś' => '&sacute;', 'Ŝ' => '&Scirc;', 'ŝ' => '&scirc;', 'Ş' => '&Scedil;', 'ş' => '&scedil;', 'Š' => '&Scaron;', 'š' => '&scaron;', 'Ţ' => '&Tcedil;', 'ţ' => '&tcedil;', 'Ť' => '&Tcaron;', 'ť' => '&tcaron;', 'Ŧ' => '&Tstrok;', 'ŧ' => '&tstrok;', 'Ũ' => '&Utilde;', 'ũ' => '&utilde;', 'Ū' => '&Umacr;', 'ū' => '&umacr;', 'Ŭ' => '&Ubreve;', 'ŭ' => '&ubreve;', 'Ů' => '&Uring;', 'ů' => '&uring;', 'Ű' => '&Udblac;', 'ű' => '&udblac;', 'Ų' => '&Uogon;', 'ų' => '&uogon;', 'Ŵ' => '&Wcirc;', 'ŵ' => '&wcirc;', 'Ŷ' => '&Ycirc;', 'ŷ' => '&ycirc;', 'Ÿ' => '&Yuml;', 'Ź' => '&Zacute;', 'ź' => '&zacute;', 'Ż' => '&Zdot;', 'ż' => '&zdot;', 'Ž' => '&Zcaron;', 'ž' => '&zcaron;', 'ƒ' => '&fnof;', 'Ƶ' => '&imped;', 'ǵ' => '&gacute;', 'ȷ' => '&jmath;', 'ˆ' => '&circ;', 'ˇ' => '&Hacek;', '˘' => '&Breve;', '˙' => '&dot;', '˚' => '&ring;', '˛' => '&ogon;', '˜' => '&DiacriticalTilde;', '˝' => '&DiacriticalDoubleAcute;', '̑' => '&DownBreve;', 'Α' => '&Alpha;', 'Β' => '&Beta;', 'Γ' => '&Gamma;', 'Δ' => '&Delta;', 'Ε' => '&Epsilon;', 'Ζ' => '&Zeta;', 'Η' => '&Eta;', 'Θ' => '&Theta;', 'Ι' => '&Iota;', 'Κ' => '&Kappa;', 'Λ' => '&Lambda;', 'Μ' => '&Mu;', 'Ν' => '&Nu;', 'Ξ' => '&Xi;', 'Ο' => '&Omicron;', 'Π' => '&Pi;', 'Ρ' => '&Rho;', 'Σ' => '&Sigma;', 'Τ' => '&Tau;', 'Υ' => '&Upsilon;', 'Φ' => '&Phi;', 'Χ' => '&Chi;', 'Ψ' => '&Psi;', 'Ω' => '&Omega;', 'α' => '&alpha;', 'β' => '&beta;', 'γ' => '&gamma;', 'δ' => '&delta;', 'ε' => '&epsi;', 'ζ' => '&zeta;', 'η' => '&eta;', 'θ' => '&theta;', 'ι' => '&iota;', 'κ' => '&kappa;', 'λ' => '&lambda;', 'μ' => '&mu;', 'ν' => '&nu;', 'ξ' => '&xi;', 'ο' => '&omicron;', 'π' => '&pi;', 'ρ' => '&rho;', 'ς' => '&sigmav;', 'σ' => '&sigma;', 'τ' => '&tau;', 'υ' => '&upsi;', 'φ' => '&phi;', 'χ' => '&chi;', 'ψ' => '&psi;', 'ω' => '&omega;', 'ϑ' => '&thetasym;', 'ϒ' => '&upsih;', 'ϕ' => '&straightphi;', 'ϖ' => '&piv;', 'Ϝ' => '&Gammad;', 'ϝ' => '&gammad;', 'ϰ' => '&varkappa;', 'ϱ' => '&rhov;', 'ϵ' => '&straightepsilon;', '϶' => '&backepsilon;', 'Ё' => '&IOcy;', 'Ђ' => '&DJcy;', 'Ѓ' => '&GJcy;', 'Є' => '&Jukcy;', 'Ѕ' => '&DScy;', 'І' => '&Iukcy;', 'Ї' => '&YIcy;', 'Ј' => '&Jsercy;', 'Љ' => '&LJcy;', 'Њ' => '&NJcy;', 'Ћ' => '&TSHcy;', 'Ќ' => '&KJcy;', 'Ў' => '&Ubrcy;', 'Џ' => '&DZcy;', 'А' => '&Acy;', 'Б' => '&Bcy;', 'В' => '&Vcy;', 'Г' => '&Gcy;', 'Д' => '&Dcy;', 'Е' => '&IEcy;', 'Ж' => '&ZHcy;', 'З' => '&Zcy;', 'И' => '&Icy;', 'Й' => '&Jcy;', 'К' => '&Kcy;', 'Л' => '&Lcy;', 'М' => '&Mcy;', 'Н' => '&Ncy;', 'О' => '&Ocy;', 'П' => '&Pcy;', 'Р' => '&Rcy;', 'С' => '&Scy;', 'Т' => '&Tcy;', 'У' => '&Ucy;', 'Ф' => '&Fcy;', 'Х' => '&KHcy;', 'Ц' => '&TScy;', 'Ч' => '&CHcy;', 'Ш' => '&SHcy;', 'Щ' => '&SHCHcy;', 'Ъ' => '&HARDcy;', 'Ы' => '&Ycy;', 'Ь' => '&SOFTcy;', 'Э' => '&Ecy;', 'Ю' => '&YUcy;', 'Я' => '&YAcy;', 'а' => '&acy;', 'б' => '&bcy;', 'в' => '&vcy;', 'г' => '&gcy;', 'д' => '&dcy;', 'е' => '&iecy;', 'ж' => '&zhcy;', 'з' => '&zcy;', 'и' => '&icy;', 'й' => '&jcy;', 'к' => '&kcy;', 'л' => '&lcy;', 'м' => '&mcy;', 'н' => '&ncy;', 'о' => '&ocy;', 'п' => '&pcy;', 'р' => '&rcy;', 'с' => '&scy;', 'т' => '&tcy;', 'у' => '&ucy;', 'ф' => '&fcy;', 'х' => '&khcy;', 'ц' => '&tscy;', 'ч' => '&chcy;', 'ш' => '&shcy;', 'щ' => '&shchcy;', 'ъ' => '&hardcy;', 'ы' => '&ycy;', 'ь' => '&softcy;', 'э' => '&ecy;', 'ю' => '&yucy;', 'я' => '&yacy;', 'ё' => '&iocy;', 'ђ' => '&djcy;', 'ѓ' => '&gjcy;', 'є' => '&jukcy;', 'ѕ' => '&dscy;', 'і' => '&iukcy;', 'ї' => '&yicy;', 'ј' => '&jsercy;', 'љ' => '&ljcy;', 'њ' => '&njcy;', 'ћ' => '&tshcy;', 'ќ' => '&kjcy;', 'ў' => '&ubrcy;', 'џ' => '&dzcy;', ' ' => '&ensp;', ' ' => '&emsp;', ' ' => '&emsp13;', ' ' => '&emsp14;', ' ' => '&numsp;', ' ' => '&puncsp;', ' ' => '&ThinSpace;', ' ' => '&hairsp;', '​' => '&ZeroWidthSpace;', '‌' => '&zwnj;', '‍' => '&zwj;', '‎' => '&lrm;', '‏' => '&rlm;', '‐' => '&hyphen;', '–' => '&ndash;', '—' => '&mdash;', '―' => '&horbar;', '‖' => '&Verbar;', '‘' => '&OpenCurlyQuote;', '’' => '&rsquo;', '‚' => '&sbquo;', '“' => '&OpenCurlyDoubleQuote;', '”' => '&rdquo;', '„' => '&bdquo;', '†' => '&dagger;', '‡' => '&Dagger;', '•' => '&bull;', '‥' => '&nldr;', '…' => '&hellip;', '‰' => '&permil;', '‱' => '&pertenk;', '′' => '&prime;', '″' => '&Prime;', '‴' => '&tprime;', '‵' => '&backprime;', '‹' => '&lsaquo;', '›' => '&rsaquo;', '‾' => '&oline;', '⁁' => '&caret;', '⁃' => '&hybull;', '⁄' => '&frasl;', '⁏' => '&bsemi;', '⁗' => '&qprime;', ' ' => '&MediumSpace;', '  ' => '&ThickSpace;', '⁠' => '&NoBreak;', '⁡' => '&af;', '⁢' => '&InvisibleTimes;', '⁣' => '&ic;', '€' => '&euro;', '⃛' => '&TripleDot;', '⃜' => '&DotDot;', 'ℂ' => '&complexes;', '℅' => '&incare;', 'ℊ' => '&gscr;', 'ℋ' => '&HilbertSpace;', 'ℌ' => '&Hfr;', 'ℍ' => '&Hopf;', 'ℎ' => '&planckh;', 'ℏ' => '&planck;', 'ℐ' => '&imagline;', 'ℑ' => '&Ifr;', 'ℒ' => '&lagran;', 'ℓ' => '&ell;', 'ℕ' => '&naturals;', '№' => '&numero;', '℗' => '&copysr;', '℘' => '&wp;', 'ℙ' => '&primes;', 'ℚ' => '&rationals;', 'ℛ' => '&realine;', 'ℜ' => '&Rfr;', 'ℝ' => '&Ropf;', '℞' => '&rx;', '™' => '&trade;', 'ℤ' => '&Zopf;', '℧' => '&mho;', 'ℨ' => '&Zfr;', '℩' => '&iiota;', 'ℬ' => '&Bscr;', 'ℭ' => '&Cfr;', 'ℯ' => '&escr;', 'ℰ' => '&expectation;', 'ℱ' => '&Fouriertrf;', 'ℳ' => '&Mellintrf;', 'ℴ' => '&orderof;', 'ℵ' => '&aleph;', 'ℶ' => '&beth;', 'ℷ' => '&gimel;', 'ℸ' => '&daleth;', 'ⅅ' => '&CapitalDifferentialD;', 'ⅆ' => '&DifferentialD;', 'ⅇ' => '&exponentiale;', 'ⅈ' => '&ImaginaryI;', '⅓' => '&frac13;', '⅔' => '&frac23;', '⅕' => '&frac15;', '⅖' => '&frac25;', '⅗' => '&frac35;', '⅘' => '&frac45;', '⅙' => '&frac16;', '⅚' => '&frac56;', '⅛' => '&frac18;', '⅜' => '&frac38;', '⅝' => '&frac58;', '⅞' => '&frac78;', '←' => '&larr;', '↑' => '&uarr;', '→' => '&srarr;', '↓' => '&darr;', '↔' => '&harr;', '↕' => '&UpDownArrow;', '↖' => '&nwarrow;', '↗' => '&UpperRightArrow;', '↘' => '&LowerRightArrow;', '↙' => '&swarr;', '↚' => '&nleftarrow;', '↛' => '&nrarr;', '↝' => '&rarrw;', '↝̸' => '&nrarrw;', '↞' => '&Larr;', '↟' => '&Uarr;', '↠' => '&twoheadrightarrow;', '↡' => '&Darr;', '↢' => '&larrtl;', '↣' => '&rarrtl;', '↤' => '&LeftTeeArrow;', '↥' => '&UpTeeArrow;', '↦' => '&map;', '↧' => '&DownTeeArrow;', '↩' => '&larrhk;', '↪' => '&rarrhk;', '↫' => '&larrlp;', '↬' => '&looparrowright;', '↭' => '&harrw;', '↮' => '&nleftrightarrow;', '↰' => '&Lsh;', '↱' => '&rsh;', '↲' => '&ldsh;', '↳' => '&rdsh;', '↵' => '&crarr;', '↶' => '&curvearrowleft;', '↷' => '&curarr;', '↺' => '&olarr;', '↻' => '&orarr;', '↼' => '&leftharpoonup;', '↽' => '&leftharpoondown;', '↾' => '&RightUpVector;', '↿' => '&uharl;', '⇀' => '&rharu;', '⇁' => '&rhard;', '⇂' => '&RightDownVector;', '⇃' => '&dharl;', '⇄' => '&rightleftarrows;', '⇅' => '&udarr;', '⇆' => '&lrarr;', '⇇' => '&llarr;', '⇈' => '&upuparrows;', '⇉' => '&rrarr;', '⇊' => '&downdownarrows;', '⇋' => '&leftrightharpoons;', '⇌' => '&rightleftharpoons;', '⇍' => '&nLeftarrow;', '⇎' => '&nhArr;', '⇏' => '&nrArr;', '⇐' => '&DoubleLeftArrow;', '⇑' => '&DoubleUpArrow;', '⇒' => '&Implies;', '⇓' => '&Downarrow;', '⇔' => '&hArr;', '⇕' => '&Updownarrow;', '⇖' => '&nwArr;', '⇗' => '&neArr;', '⇘' => '&seArr;', '⇙' => '&swArr;', '⇚' => '&lAarr;', '⇛' => '&rAarr;', '⇝' => '&zigrarr;', '⇤' => '&LeftArrowBar;', '⇥' => '&RightArrowBar;', '⇵' => '&DownArrowUpArrow;', '⇽' => '&loarr;', '⇾' => '&roarr;', '⇿' => '&hoarr;', '∀' => '&forall;', '∁' => '&comp;', '∂' => '&part;', '∂̸' => '&npart;', '∃' => '&Exists;', '∄' => '&nexist;', '∅' => '&empty;', '∇' => '&nabla;', '∈' => '&isinv;', '∉' => '&notin;', '∋' => '&ReverseElement;', '∌' => '&notniva;', '∏' => '&prod;', '∐' => '&Coproduct;', '∑' => '&sum;', '−' => '&minus;', '∓' => '&MinusPlus;', '∔' => '&plusdo;', '∖' => '&ssetmn;', '∗' => '&lowast;', '∘' => '&compfn;', '√' => '&Sqrt;', '∝' => '&prop;', '∞' => '&infin;', '∟' => '&angrt;', '∠' => '&angle;', '∠⃒' => '&nang;', '∡' => '&angmsd;', '∢' => '&angsph;', '∣' => '&mid;', '∤' => '&nshortmid;', '∥' => '&shortparallel;', '∦' => '&nparallel;', '∧' => '&and;', '∨' => '&or;', '∩' => '&cap;', '∩︀' => '&caps;', '∪' => '&cup;', '∪︀' => '&cups', '∫' => '&Integral;', '∬' => '&Int;', '∭' => '&tint;', '∮' => '&ContourIntegral;', '∯' => '&DoubleContourIntegral;', '∰' => '&Cconint;', '∱' => '&cwint;', '∲' => '&cwconint;', '∳' => '&awconint;', '∴' => '&there4;', '∵' => '&Because;', '∶' => '&ratio;', '∷' => '&Colon;', '∸' => '&minusd;', '∺' => '&mDDot;', '∻' => '&homtht;', '∼' => '&sim;', '∼⃒' => '&nvsim;', '∽' => '&bsim;', '∽̱' => '&race;', '∾' => '&ac;', '∾̳' => '&acE;', '∿' => '&acd;', '≀' => '&wr;', '≁' => '&NotTilde;', '≂' => '&esim;', '≂̸' => '&nesim;', '≃' => '&simeq;', '≄' => '&nsime;', '≅' => '&TildeFullEqual;', '≆' => '&simne;', '≇' => '&ncong;', '≈' => '&approx;', '≉' => '&napprox;', '≊' => '&ape;', '≋' => '&apid;', '≋̸' => '&napid;', '≌' => '&bcong;', '≍' => '&CupCap;', '≍⃒' => '&nvap;', '≎' => '&bump;', '≎̸' => '&nbump;', '≏' => '&HumpEqual;', '≏̸' => '&nbumpe;', '≐' => '&esdot;', '≐̸' => '&nedot;', '≑' => '&doteqdot;', '≒' => '&fallingdotseq;', '≓' => '&risingdotseq;', '≔' => '&coloneq;', '≕' => '&eqcolon;', '≖' => '&ecir;', '≗' => '&circeq;', '≙' => '&wedgeq;', '≚' => '&veeeq;', '≜' => '&triangleq;', '≟' => '&equest;', '≠' => '&NotEqual;', '≡' => '&Congruent;', '≡⃥' => '&bnequiv;', '≢' => '&NotCongruent;', '≤' => '&leq;', '≤⃒' => '&nvle;', '≥' => '&ge;', '≥⃒' => '&nvge;', '≦' => '&lE;', '≦̸' => '&nlE;', '≧' => '&geqq;', '≧̸' => '&NotGreaterFullEqual;', '≨' => '&lneqq;', '≨︀' => '&lvertneqq;', '≩' => '&gneqq;', '≩︀' => '&gvertneqq;', '≪' => '&ll;', '≪̸' => '&nLtv;', '≪⃒' => '&nLt;', '≫' => '&gg;', '≫̸' => '&NotGreaterGreater;', '≫⃒' => '&nGt;', '≬' => '&between;', '≭' => '&NotCupCap;', '≮' => '&NotLess;', '≯' => '&ngtr;', '≰' => '&NotLessEqual;', '≱' => '&ngeq;', '≲' => '&LessTilde;', '≳' => '&GreaterTilde;', '≴' => '&nlsim;', '≵' => '&ngsim;', '≶' => '&lessgtr;', '≷' => '&gl;', '≸' => '&ntlg;', '≹' => '&NotGreaterLess;', '≺' => '&prec;', '≻' => '&succ;', '≼' => '&PrecedesSlantEqual;', '≽' => '&succcurlyeq;', '≾' => '&precsim;', '≿' => '&SucceedsTilde;', '≿̸' => '&NotSucceedsTilde;', '⊀' => '&npr;', '⊁' => '&NotSucceeds;', '⊂' => '&sub;', '⊂⃒' => '&vnsub;', '⊃' => '&sup;', '⊃⃒' => '&nsupset;', '⊄' => '&nsub;', '⊅' => '&nsup;', '⊆' => '&SubsetEqual;', '⊇' => '&supe;', '⊈' => '&NotSubsetEqual;', '⊉' => '&NotSupersetEqual;', '⊊' => '&subsetneq;', '⊊︀' => '&vsubne;', '⊋' => '&supsetneq;', '⊋︀' => '&vsupne;', '⊍' => '&cupdot;', '⊎' => '&UnionPlus;', '⊏' => '&sqsub;', '⊏̸' => '&NotSquareSubset;', '⊐' => '&sqsupset;', '⊐̸' => '&NotSquareSuperset;', '⊑' => '&SquareSubsetEqual;', '⊒' => '&SquareSupersetEqual;', '⊓' => '&sqcap;', '⊓︀' => '&sqcaps;', '⊔' => '&sqcup;', '⊔︀' => '&sqcups;', '⊕' => '&CirclePlus;', '⊖' => '&ominus;', '⊗' => '&CircleTimes;', '⊘' => '&osol;', '⊙' => '&CircleDot;', '⊚' => '&ocir;', '⊛' => '&oast;', '⊝' => '&odash;', '⊞' => '&boxplus;', '⊟' => '&boxminus;', '⊠' => '&timesb;', '⊡' => '&sdotb;', '⊢' => '&vdash;', '⊣' => '&dashv;', '⊤' => '&DownTee;', '⊥' => '&perp;', '⊧' => '&models;', '⊨' => '&DoubleRightTee;', '⊩' => '&Vdash;', '⊪' => '&Vvdash;', '⊫' => '&VDash;', '⊬' => '&nvdash;', '⊭' => '&nvDash;', '⊮' => '&nVdash;', '⊯' => '&nVDash;', '⊰' => '&prurel;', '⊲' => '&vartriangleleft;', '⊳' => '&vrtri;', '⊴' => '&LeftTriangleEqual;', '⊴⃒' => '&nvltrie;', '⊵' => '&RightTriangleEqual;', '⊵⃒' => '&nvrtrie;', '⊶' => '&origof;', '⊷' => '&imof;', '⊸' => '&mumap;', '⊹' => '&hercon;', '⊺' => '&intcal;', '⊻' => '&veebar;', '⊽' => '&barvee;', '⊾' => '&angrtvb;', '⊿' => '&lrtri;', '⋀' => '&xwedge;', '⋁' => '&xvee;', '⋂' => '&bigcap;', '⋃' => '&bigcup;', '⋄' => '&diamond;', '⋅' => '&sdot;', '⋆' => '&Star;', '⋇' => '&divonx;', '⋈' => '&bowtie;', '⋉' => '&ltimes;', '⋊' => '&rtimes;', '⋋' => '&lthree;', '⋌' => '&rthree;', '⋍' => '&backsimeq;', '⋎' => '&curlyvee;', '⋏' => '&curlywedge;', '⋐' => '&Sub;', '⋑' => '&Supset;', '⋒' => '&Cap;', '⋓' => '&Cup;', '⋔' => '&pitchfork;', '⋕' => '&epar;', '⋖' => '&lessdot;', '⋗' => '&gtrdot;', '⋘' => '&Ll;', '⋘̸' => '&nLl;', '⋙' => '&Gg;', '⋙̸' => '&nGg;', '⋚' => '&lesseqgtr;', '⋚︀' => '&lesg;', '⋛' => '&gtreqless;', '⋛︀' => '&gesl;', '⋞' => '&curlyeqprec;', '⋟' => '&cuesc;', '⋠' => '&NotPrecedesSlantEqual;', '⋡' => '&NotSucceedsSlantEqual;', '⋢' => '&NotSquareSubsetEqual;', '⋣' => '&NotSquareSupersetEqual;', '⋦' => '&lnsim;', '⋧' => '&gnsim;', '⋨' => '&precnsim;', '⋩' => '&scnsim;', '⋪' => '&nltri;', '⋫' => '&ntriangleright;', '⋬' => '&nltrie;', '⋭' => '&NotRightTriangleEqual;', '⋮' => '&vellip;', '⋯' => '&ctdot;', '⋰' => '&utdot;', '⋱' => '&dtdot;', '⋲' => '&disin;', '⋳' => '&isinsv;', '⋴' => '&isins;', '⋵' => '&isindot;', '⋵̸' => '&notindot;', '⋶' => '&notinvc;', '⋷' => '&notinvb;', '⋹' => '&isinE;', '⋹̸' => '&notinE;', '⋺' => '&nisd;', '⋻' => '&xnis;', '⋼' => '&nis;', '⋽' => '&notnivc;', '⋾' => '&notnivb;', '⌅' => '&barwed;', '⌆' => '&doublebarwedge;', '⌈' => '&lceil;', '⌉' => '&RightCeiling;', '⌊' => '&LeftFloor;', '⌋' => '&RightFloor;', '⌌' => '&drcrop;', '⌍' => '&dlcrop;', '⌎' => '&urcrop;', '⌏' => '&ulcrop;', '⌐' => '&bnot;', '⌒' => '&profline;', '⌓' => '&profsurf;', '⌕' => '&telrec;', '⌖' => '&target;', '⌜' => '&ulcorner;', '⌝' => '&urcorner;', '⌞' => '&llcorner;', '⌟' => '&drcorn;', '⌢' => '&frown;', '⌣' => '&smile;', '⌭' => '&cylcty;', '⌮' => '&profalar;', '⌶' => '&topbot;', '⌽' => '&ovbar;', '⌿' => '&solbar;', '⍼' => '&angzarr;', '⎰' => '&lmoust;', '⎱' => '&rmoust;', '⎴' => '&OverBracket;', '⎵' => '&bbrk;', '⎶' => '&bbrktbrk;', '⏜' => '&OverParenthesis;', '⏝' => '&UnderParenthesis;', '⏞' => '&OverBrace;', '⏟' => '&UnderBrace;', '⏢' => '&trpezium;', '⏧' => '&elinters;', '␣' => '&blank;', 'Ⓢ' => '&oS;', '─' => '&HorizontalLine;', '│' => '&boxv;', '┌' => '&boxdr;', '┐' => '&boxdl;', '└' => '&boxur;', '┘' => '&boxul;', '├' => '&boxvr;', '┤' => '&boxvl;', '┬' => '&boxhd;', '┴' => '&boxhu;', '┼' => '&boxvh;', '═' => '&boxH;', '║' => '&boxV;', '╒' => '&boxdR;', '╓' => '&boxDr;', '╔' => '&boxDR;', '╕' => '&boxdL;', '╖' => '&boxDl;', '╗' => '&boxDL;', '╘' => '&boxuR;', '╙' => '&boxUr;', '╚' => '&boxUR;', '╛' => '&boxuL;', '╜' => '&boxUl;', '╝' => '&boxUL;', '╞' => '&boxvR;', '╟' => '&boxVr;', '╠' => '&boxVR;', '╡' => '&boxvL;', '╢' => '&boxVl;', '╣' => '&boxVL;', '╤' => '&boxHd;', '╥' => '&boxhD;', '╦' => '&boxHD;', '╧' => '&boxHu;', '╨' => '&boxhU;', '╩' => '&boxHU;', '╪' => '&boxvH;', '╫' => '&boxVh;', '╬' => '&boxVH;', '▀' => '&uhblk;', '▄' => '&lhblk;', '█' => '&block;', '░' => '&blk14;', '▒' => '&blk12;', '▓' => '&blk34;', '□' => '&Square;', '▪' => '&squarf;', '▫' => '&EmptyVerySmallSquare;', '▭' => '&rect;', '▮' => '&marker;', '▱' => '&fltns;', '△' => '&bigtriangleup;', '▴' => '&blacktriangle;', '▵' => '&triangle;', '▸' => '&blacktriangleright;', '▹' => '&rtri;', '▽' => '&bigtriangledown;', '▾' => '&blacktriangledown;', '▿' => '&triangledown;', '◂' => '&blacktriangleleft;', '◃' => '&ltri;', '◊' => '&lozenge;', '○' => '&cir;', '◬' => '&tridot;', '◯' => '&bigcirc;', '◸' => '&ultri;', '◹' => '&urtri;', '◺' => '&lltri;', '◻' => '&EmptySmallSquare;', '◼' => '&FilledSmallSquare;', '★' => '&starf;', '☆' => '&star;', '☎' => '&phone;', '♀' => '&female;', '♂' => '&male;', '♠' => '&spadesuit;', '♣' => '&clubs;', '♥' => '&hearts;', '♦' => '&diamondsuit;', '♪' => '&sung;', '♭' => '&flat;', '♮' => '&natur;', '♯' => '&sharp;', '✓' => '&check;', '✗' => '&cross;', '✠' => '&maltese;', '✶' => '&sext;', '❘' => '&VerticalSeparator;', '❲' => '&lbbrk;', '❳' => '&rbbrk;', '⟈' => '&bsolhsub;', '⟉' => '&suphsol;', '⟦' => '&LeftDoubleBracket;', '⟧' => '&RightDoubleBracket;', '⟨' => '&langle;', '⟩' => '&RightAngleBracket;', '⟪' => '&Lang;', '⟫' => '&Rang;', '⟬' => '&loang;', '⟭' => '&roang;', '⟵' => '&longleftarrow;', '⟶' => '&LongRightArrow;', '⟷' => '&LongLeftRightArrow;', '⟸' => '&xlArr;', '⟹' => '&DoubleLongRightArrow;', '⟺' => '&xhArr;', '⟼' => '&xmap;', '⟿' => '&dzigrarr;', '⤂' => '&nvlArr;', '⤃' => '&nvrArr;', '⤄' => '&nvHarr;', '⤅' => '&Map;', '⤌' => '&lbarr;', '⤍' => '&bkarow;', '⤎' => '&lBarr;', '⤏' => '&dbkarow;', '⤐' => '&drbkarow;', '⤑' => '&DDotrahd;', '⤒' => '&UpArrowBar;', '⤓' => '&DownArrowBar;', '⤖' => '&Rarrtl;', '⤙' => '&latail;', '⤚' => '&ratail;', '⤛' => '&lAtail;', '⤜' => '&rAtail;', '⤝' => '&larrfs;', '⤞' => '&rarrfs;', '⤟' => '&larrbfs;', '⤠' => '&rarrbfs;', '⤣' => '&nwarhk;', '⤤' => '&nearhk;', '⤥' => '&searhk;', '⤦' => '&swarhk;', '⤧' => '&nwnear;', '⤨' => '&toea;', '⤩' => '&seswar;', '⤪' => '&swnwar;', '⤳' => '&rarrc;', '⤳̸' => '&nrarrc;', '⤵' => '&cudarrr;', '⤶' => '&ldca;', '⤷' => '&rdca;', '⤸' => '&cudarrl;', '⤹' => '&larrpl;', '⤼' => '&curarrm;', '⤽' => '&cularrp;', '⥅' => '&rarrpl;', '⥈' => '&harrcir;', '⥉' => '&Uarrocir;', '⥊' => '&lurdshar;', '⥋' => '&ldrushar;', '⥎' => '&LeftRightVector;', '⥏' => '&RightUpDownVector;', '⥐' => '&DownLeftRightVector;', '⥑' => '&LeftUpDownVector;', '⥒' => '&LeftVectorBar;', '⥓' => '&RightVectorBar;', '⥔' => '&RightUpVectorBar;', '⥕' => '&RightDownVectorBar;', '⥖' => '&DownLeftVectorBar;', '⥗' => '&DownRightVectorBar;', '⥘' => '&LeftUpVectorBar;', '⥙' => '&LeftDownVectorBar;', '⥚' => '&LeftTeeVector;', '⥛' => '&RightTeeVector;', '⥜' => '&RightUpTeeVector;', '⥝' => '&RightDownTeeVector;', '⥞' => '&DownLeftTeeVector;', '⥟' => '&DownRightTeeVector;', '⥠' => '&LeftUpTeeVector;', '⥡' => '&LeftDownTeeVector;', '⥢' => '&lHar;', '⥣' => '&uHar;', '⥤' => '&rHar;', '⥥' => '&dHar;', '⥦' => '&luruhar;', '⥧' => '&ldrdhar;', '⥨' => '&ruluhar;', '⥩' => '&rdldhar;', '⥪' => '&lharul;', '⥫' => '&llhard;', '⥬' => '&rharul;', '⥭' => '&lrhard;', '⥮' => '&udhar;', '⥯' => '&ReverseUpEquilibrium;', '⥰' => '&RoundImplies;', '⥱' => '&erarr;', '⥲' => '&simrarr;', '⥳' => '&larrsim;', '⥴' => '&rarrsim;', '⥵' => '&rarrap;', '⥶' => '&ltlarr;', '⥸' => '&gtrarr;', '⥹' => '&subrarr;', '⥻' => '&suplarr;', '⥼' => '&lfisht;', '⥽' => '&rfisht;', '⥾' => '&ufisht;', '⥿' => '&dfisht;', '⦅' => '&lopar;', '⦆' => '&ropar;', '⦋' => '&lbrke;', '⦌' => '&rbrke;', '⦍' => '&lbrkslu;', '⦎' => '&rbrksld;', '⦏' => '&lbrksld;', '⦐' => '&rbrkslu;', '⦑' => '&langd;', '⦒' => '&rangd;', '⦓' => '&lparlt;', '⦔' => '&rpargt;', '⦕' => '&gtlPar;', '⦖' => '&ltrPar;', '⦚' => '&vzigzag;', '⦜' => '&vangrt;', '⦝' => '&angrtvbd;', '⦤' => '&ange;', '⦥' => '&range;', '⦦' => '&dwangle;', '⦧' => '&uwangle;', '⦨' => '&angmsdaa;', '⦩' => '&angmsdab;', '⦪' => '&angmsdac;', '⦫' => '&angmsdad;', '⦬' => '&angmsdae;', '⦭' => '&angmsdaf;', '⦮' => '&angmsdag;', '⦯' => '&angmsdah;', '⦰' => '&bemptyv;', '⦱' => '&demptyv;', '⦲' => '&cemptyv;', '⦳' => '&raemptyv;', '⦴' => '&laemptyv;', '⦵' => '&ohbar;', '⦶' => '&omid;', '⦷' => '&opar;', '⦹' => '&operp;', '⦻' => '&olcross;', '⦼' => '&odsold;', '⦾' => '&olcir;', '⦿' => '&ofcir;', '⧀' => '&olt;', '⧁' => '&ogt;', '⧂' => '&cirscir;', '⧃' => '&cirE;', '⧄' => '&solb;', '⧅' => '&bsolb;', '⧉' => '&boxbox;', '⧍' => '&trisb;', '⧎' => '&rtriltri;', '⧏' => '&LeftTriangleBar;', '⧏̸' => '&NotLeftTriangleBar;', '⧐' => '&RightTriangleBar;', '⧐̸' => '&NotRightTriangleBar;', '⧜' => '&iinfin;', '⧝' => '&infintie;', '⧞' => '&nvinfin;', '⧣' => '&eparsl;', '⧤' => '&smeparsl;', '⧥' => '&eqvparsl;', '⧫' => '&lozf;', '⧴' => '&RuleDelayed;', '⧶' => '&dsol;', '⨀' => '&xodot;', '⨁' => '&bigoplus;', '⨂' => '&bigotimes;', '⨄' => '&biguplus;', '⨆' => '&bigsqcup;', '⨌' => '&iiiint;', '⨍' => '&fpartint;', '⨐' => '&cirfnint;', '⨑' => '&awint;', '⨒' => '&rppolint;', '⨓' => '&scpolint;', '⨔' => '&npolint;', '⨕' => '&pointint;', '⨖' => '&quatint;', '⨗' => '&intlarhk;', '⨢' => '&pluscir;', '⨣' => '&plusacir;', '⨤' => '&simplus;', '⨥' => '&plusdu;', '⨦' => '&plussim;', '⨧' => '&plustwo;', '⨩' => '&mcomma;', '⨪' => '&minusdu;', '⨭' => '&loplus;', '⨮' => '&roplus;', '⨯' => '&Cross;', '⨰' => '&timesd;', '⨱' => '&timesbar;', '⨳' => '&smashp;', '⨴' => '&lotimes;', '⨵' => '&rotimes;', '⨶' => '&otimesas;', '⨷' => '&Otimes;', '⨸' => '&odiv;', '⨹' => '&triplus;', '⨺' => '&triminus;', '⨻' => '&tritime;', '⨼' => '&iprod;', '⨿' => '&amalg;', '⩀' => '&capdot;', '⩂' => '&ncup;', '⩃' => '&ncap;', '⩄' => '&capand;', '⩅' => '&cupor;', '⩆' => '&cupcap;', '⩇' => '&capcup;', '⩈' => '&cupbrcap;', '⩉' => '&capbrcup;', '⩊' => '&cupcup;', '⩋' => '&capcap;', '⩌' => '&ccups;', '⩍' => '&ccaps;', '⩐' => '&ccupssm;', '⩓' => '&And;', '⩔' => '&Or;', '⩕' => '&andand;', '⩖' => '&oror;', '⩗' => '&orslope;', '⩘' => '&andslope;', '⩚' => '&andv;', '⩛' => '&orv;', '⩜' => '&andd;', '⩝' => '&ord;', '⩟' => '&wedbar;', '⩦' => '&sdote;', '⩪' => '&simdot;', '⩭' => '&congdot;', '⩭̸' => '&ncongdot;', '⩮' => '&easter;', '⩯' => '&apacir;', '⩰' => '&apE;', '⩰̸' => '&napE;', '⩱' => '&eplus;', '⩲' => '&pluse;', '⩳' => '&Esim;', '⩴' => '&Colone;', '⩵' => '&Equal;', '⩷' => '&ddotseq;', '⩸' => '&equivDD;', '⩹' => '&ltcir;', '⩺' => '&gtcir;', '⩻' => '&ltquest;', '⩼' => '&gtquest;', '⩽' => '&les;', '⩽̸' => '&nles;', '⩾' => '&ges;', '⩾̸' => '&nges;', '⩿' => '&lesdot;', '⪀' => '&gesdot;', '⪁' => '&lesdoto;', '⪂' => '&gesdoto;', '⪃' => '&lesdotor;', '⪄' => '&gesdotol;', '⪅' => '&lap;', '⪆' => '&gap;', '⪇' => '&lne;', '⪈' => '&gne;', '⪉' => '&lnap;', '⪊' => '&gnap;', '⪋' => '&lesseqqgtr;', '⪌' => '&gEl;', '⪍' => '&lsime;', '⪎' => '&gsime;', '⪏' => '&lsimg;', '⪐' => '&gsiml;', '⪑' => '&lgE;', '⪒' => '&glE;', '⪓' => '&lesges;', '⪔' => '&gesles;', '⪕' => '&els;', '⪖' => '&egs;', '⪗' => '&elsdot;', '⪘' => '&egsdot;', '⪙' => '&el;', '⪚' => '&eg;', '⪝' => '&siml;', '⪞' => '&simg;', '⪟' => '&simlE;', '⪠' => '&simgE;', '⪡' => '&LessLess;', '⪡̸' => '&NotNestedLessLess;', '⪢' => '&GreaterGreater;', '⪢̸' => '&NotNestedGreaterGreater;', '⪤' => '&glj;', '⪥' => '&gla;', '⪦' => '&ltcc;', '⪧' => '&gtcc;', '⪨' => '&lescc;', '⪩' => '&gescc;', '⪪' => '&smt;', '⪫' => '&lat;', '⪬' => '&smte;', '⪬︀' => '&smtes;', '⪭' => '&late;', '⪭︀' => '&lates;', '⪮' => '&bumpE;', '⪯' => '&preceq;', '⪯̸' => '&NotPrecedesEqual;', '⪰' => '&SucceedsEqual;', '⪰̸' => '&NotSucceedsEqual;', '⪳' => '&prE;', '⪴' => '&scE;', '⪵' => '&precneqq;', '⪶' => '&scnE;', '⪷' => '&precapprox;', '⪸' => '&succapprox;', '⪹' => '&precnapprox;', '⪺' => '&succnapprox;', '⪻' => '&Pr;', '⪼' => '&Sc;', '⪽' => '&subdot;', '⪾' => '&supdot;', '⪿' => '&subplus;', '⫀' => '&supplus;', '⫁' => '&submult;', '⫂' => '&supmult;', '⫃' => '&subedot;', '⫄' => '&supedot;', '⫅' => '&subE;', '⫅̸' => '&nsubE;', '⫆' => '&supseteqq;', '⫆̸' => '&nsupseteqq;', '⫇' => '&subsim;', '⫈' => '&supsim;', '⫋' => '&subsetneqq;', '⫋︀' => '&vsubnE;', '⫌' => '&supnE;', '⫌︀' => '&varsupsetneqq;', '⫏' => '&csub;', '⫐' => '&csup;', '⫑' => '&csube;', '⫒' => '&csupe;', '⫓' => '&subsup;', '⫔' => '&supsub;', '⫕' => '&subsub;', '⫖' => '&supsup;', '⫗' => '&suphsub;', '⫘' => '&supdsub;', '⫙' => '&forkv;', '⫚' => '&topfork;', '⫛' => '&mlcp;', '⫤' => '&Dashv;', '⫦' => '&Vdashl;', '⫧' => '&Barv;', '⫨' => '&vBar;', '⫩' => '&vBarv;', '⫫' => '&Vbar;', '⫬' => '&Not;', '⫭' => '&bNot;', '⫮' => '&rnmid;', '⫯' => '&cirmid;', '⫰' => '&midcir;', '⫱' => '&topcir;', '⫲' => '&nhpar;', '⫳' => '&parsim;', '⫽' => '&parsl;', '⫽⃥' => '&nparsl;', 'ﬀ' => '&fflig;', 'ﬁ' => '&filig;', 'ﬂ' => '&fllig;', 'ﬃ' => '&ffilig;', 'ﬄ' => '&ffllig;', '𝒜' => '&Ascr;', '𝒞' => '&Cscr;', '𝒟' => '&Dscr;', '𝒢' => '&Gscr;', '𝒥' => '&Jscr;', '𝒦' => '&Kscr;', '𝒩' => '&Nscr;', '𝒪' => '&Oscr;', '𝒫' => '&Pscr;', '𝒬' => '&Qscr;', '𝒮' => '&Sscr;', '𝒯' => '&Tscr;', '𝒰' => '&Uscr;', '𝒱' => '&Vscr;', '𝒲' => '&Wscr;', '𝒳' => '&Xscr;', '𝒴' => '&Yscr;', '𝒵' => '&Zscr;', '𝒶' => '&ascr;', '𝒷' => '&bscr;', '𝒸' => '&cscr;', '𝒹' => '&dscr;', '𝒻' => '&fscr;', '𝒽' => '&hscr;', '𝒾' => '&iscr;', '𝒿' => '&jscr;', '𝓀' => '&kscr;', '𝓁' => '&lscr;', '𝓂' => '&mscr;', '𝓃' => '&nscr;', '𝓅' => '&pscr;', '𝓆' => '&qscr;', '𝓇' => '&rscr;', '𝓈' => '&sscr;', '𝓉' => '&tscr;', '𝓊' => '&uscr;', '𝓋' => '&vscr;', '𝓌' => '&wscr;', '𝓍' => '&xscr;', '𝓎' => '&yscr;', '𝓏' => '&zscr;', '𝔄' => '&Afr;', '𝔅' => '&Bfr;', '𝔇' => '&Dfr;', '𝔈' => '&Efr;', '𝔉' => '&Ffr;', '𝔊' => '&Gfr;', '𝔍' => '&Jfr;', '𝔎' => '&Kfr;', '𝔏' => '&Lfr;', '𝔐' => '&Mfr;', '𝔑' => '&Nfr;', '𝔒' => '&Ofr;', '𝔓' => '&Pfr;', '𝔔' => '&Qfr;', '𝔖' => '&Sfr;', '𝔗' => '&Tfr;', '𝔘' => '&Ufr;', '𝔙' => '&Vfr;', '𝔚' => '&Wfr;', '𝔛' => '&Xfr;', '𝔜' => '&Yfr;', '𝔞' => '&afr;', '𝔟' => '&bfr;', '𝔠' => '&cfr;', '𝔡' => '&dfr;', '𝔢' => '&efr;', '𝔣' => '&ffr;', '𝔤' => '&gfr;', '𝔥' => '&hfr;', '𝔦' => '&ifr;', '𝔧' => '&jfr;', '𝔨' => '&kfr;', '𝔩' => '&lfr;', '𝔪' => '&mfr;', '𝔫' => '&nfr;', '𝔬' => '&ofr;', '𝔭' => '&pfr;', '𝔮' => '&qfr;', '𝔯' => '&rfr;', '𝔰' => '&sfr;', '𝔱' => '&tfr;', '𝔲' => '&ufr;', '𝔳' => '&vfr;', '𝔴' => '&wfr;', '𝔵' => '&xfr;', '𝔶' => '&yfr;', '𝔷' => '&zfr;', '𝔸' => '&Aopf;', '𝔹' => '&Bopf;', '𝔻' => '&Dopf;', '𝔼' => '&Eopf;', '𝔽' => '&Fopf;', '𝔾' => '&Gopf;', '𝕀' => '&Iopf;', '𝕁' => '&Jopf;', '𝕂' => '&Kopf;', '𝕃' => '&Lopf;', '𝕄' => '&Mopf;', '𝕆' => '&Oopf;', '𝕊' => '&Sopf;', '𝕋' => '&Topf;', '𝕌' => '&Uopf;', '𝕍' => '&Vopf;', '𝕎' => '&Wopf;', '𝕏' => '&Xopf;', '𝕐' => '&Yopf;', '𝕒' => '&aopf;', '𝕓' => '&bopf;', '𝕔' => '&copf;', '𝕕' => '&dopf;', '𝕖' => '&eopf;', '𝕗' => '&fopf;', '𝕘' => '&gopf;', '𝕙' => '&hopf;', '𝕚' => '&iopf;', '𝕛' => '&jopf;', '𝕜' => '&kopf;', '𝕝' => '&lopf;', '𝕞' => '&mopf;', '𝕟' => '&nopf;', '𝕠' => '&oopf;', '𝕡' => '&popf;', '𝕢' => '&qopf;', '𝕣' => '&ropf;', '𝕤' => '&sopf;', '𝕥' => '&topf;', '𝕦' => '&uopf;', '𝕧' => '&vopf;', '𝕨' => '&wopf;', '𝕩' => '&xopf;', '𝕪' => '&yopf;', '𝕫' => '&zopf;', ]; private static $_never_allowed_regex = [ 'javascript\s*:', '(document|(document\.)?window)\.(location|on\w*)', 'jar\s*:', 'applescript\s*:', 'vbscript\s*:', 'wscript\s*:', 'jscript\s*:', 'vbs\s*:', 'behavior\s:', 'Redirect\s+30\d', "([\"'])?data\s*:[^\\1]*?base64[^\\1]*?,[^\\1]*?\\1?", '&\s*\{[^}]*(\}\s*;?|$)', 'expression\s*(\(|&\#40;)', 'mocha\s*:', 'livescript\s*:', 'view-source\s*:', ]; private static $_never_allowed_str_afterwards = [ 'FSCommand', 'onAbort', 'onActivate', 'onAttribute', 'onAfterPrint', 'onAfterScriptExecute', 'onAfterUpdate', 'onAnimationEnd', 'onAnimationIteration', 'onAnimationStart', 'onAriaRequest', 'onAutoComplete', 'onAutoCompleteError', 'onBeforeActivate', 'onBeforeCopy', 'onBeforeCut', 'onBeforeDeactivate', 'onBeforeEditFocus', 'onBeforePaste', 'onBeforePrint', 'onBeforeScriptExecute', 'onBeforeUnload', 'onBeforeUpdate', 'onBegin', 'onBlur', 'onBounce', 'onCancel', 'onCanPlay', 'onCanPlayThrough', 'onCellChange', 'onChange', 'onClick', 'onClose', 'onCommand', 'onCompassNeedsCalibration', 'onContextMenu', 'onControlSelect', 'onCopy', 'onCueChange', 'onCut', 'onDataAvailable', 'onDataSetChanged', 'onDataSetComplete', 'onDblClick', 'onDeactivate', 'onDeviceLight', 'onDeviceMotion', 'onDeviceOrientation', 'onDeviceProximity', 'onDrag', 'onDragDrop', 'onDragEnd', 'onDragEnter', 'onDragLeave', 'onDragOver', 'onDragStart', 'onDrop', 'onDurationChange', 'onEmptied', 'onEnd', 'onEnded', 'onError', 'onErrorUpdate', 'onExit', 'onFilterChange', 'onFinish', 'onFocus', 'onFocusIn', 'onFocusOut', 'onFormChange', 'onFormInput', 'onFullScreenChange', 'onFullScreenError', 'onGotPointerCapture', 'onHashChange', 'onHelp', 'onInput', 'onInvalid', 'onKeyDown', 'onKeyPress', 'onKeyUp', 'onLanguageChange', 'onLayoutComplete', 'onLoad', 'onLoadedData', 'onLoadedMetaData', 'onLoadStart', 'onLoseCapture', 'onLostPointerCapture', 'onMediaComplete', 'onMediaError', 'onMessage', 'onMouseDown', 'onMouseEnter', 'onMouseLeave', 'onMouseMove', 'onMouseOut', 'onMouseOver', 'onMouseUp', 'onMouseWheel', 'onMove', 'onMoveEnd', 'onMoveStart', 'onMozFullScreenChange', 'onMozFullScreenError', 'onMozPointerLockChange', 'onMozPointerLockError', 'onMsContentZoom', 'onMsFullScreenChange', 'onMsFullScreenError', 'onMsGestureChange', 'onMsGestureDoubleTap', 'onMsGestureEnd', 'onMsGestureHold', 'onMsGestureStart', 'onMsGestureTap', 'onMsGotPointerCapture', 'onMsInertiaStart', 'onMsLostPointerCapture', 'onMsManipulationStateChanged', 'onMsPointerCancel', 'onMsPointerDown', 'onMsPointerEnter', 'onMsPointerLeave', 'onMsPointerMove', 'onMsPointerOut', 'onMsPointerOver', 'onMsPointerUp', 'onMsSiteModeJumpListItemRemoved', 'onMsThumbnailClick', 'onOffline', 'onOnline', 'onOutOfSync', 'onPage', 'onPageHide', 'onPageShow', 'onPaste', 'onPause', 'onPlay', 'onPlaying', 'onPointerCancel', 'onPointerDown', 'onPointerEnter', 'onPointerLeave', 'onPointerLockChange', 'onPointerLockError', 'onPointerMove', 'onPointerOut', 'onPointerOver', 'onPointerUp', 'onPopState', 'onProgress', 'onPropertyChange', 'onRateChange', 'onReadyStateChange', 'onReceived', 'onRepeat', 'onReset', 'onResize', 'onResizeEnd', 'onResizeStart', 'onResume', 'onReverse', 'onRowDelete', 'onRowEnter', 'onRowExit', 'onRowInserted', 'onRowsDelete', 'onRowsEnter', 'onRowsExit', 'onRowsInserted', 'onScroll', 'onSearch', 'onSeek', 'onSeeked', 'onSeeking', 'onSelect', 'onSelectionChange', 'onSelectStart', 'onStalled', 'onStorage', 'onStorageCommit', 'onStart', 'onStop', 'onShow', 'onSyncRestored', 'onSubmit', 'onSuspend', 'onSynchRestored', 'onTimeError', 'onTimeUpdate', 'onTrackChange', 'onTransitionEnd', 'onToggle', 'onUnload', 'onURLFlip', 'onUserProximity', 'onVolumeChange', 'onWaiting', 'onWebKitAnimationEnd', 'onWebKitAnimationIteration', 'onWebKitAnimationStart', 'onWebKitFullScreenChange', 'onWebKitFullScreenError', 'onWebKitTransitionEnd', 'onWheel', 'ev:handler', 'ev:event', '0;url', ]; private $_evil_attributes = [ 'on\w*', 'style', 'xmlns', 'formaction', 'form', 'xlink:href', 'seekSegmentTime', 'userid', 'datasrc', 'datafld', 'dataformatas', 'FSCommand', ]; private $_evil_html_tags = [ 'applet', 'alert', 'audio', 'basefont', 'base', 'behavior', 'bgsound', 'blink', 'body', 'embed', 'eval', 'expression', 'form', 'frameset', 'frame', 'head', 'html', 'ilayer', 'iframe', 'input', 'button', 'select', 'isindex', 'layer', 'link', 'meta', 'keygen', 'object', 'plaintext', 'style', 'script', 'textarea', 'title', 'math', 'video', 'source', 'svg', 'xml', 'xss', ]; private $_xss_hash; private $_replacement = ''; private $_never_allowed_str = []; private $_stripe_4byte_chars = false; private $xss_found; public function __construct() { $this->_initNeverAllowedStr(); } private function _compact_exploded_words_callback($matches): string { return \preg_replace('/(?:\s+|"|\042|\'|\047|\+)*+/', '', $matches[1]) . $matches[2]; } private function _decode_entity(array $match): string { $this->_xss_hash(); $str = $match[0]; $str = (string)\preg_replace('|\?([a-z\_0-9\-]+)\=([a-z\_0-9\-/]+)|i', $this->_xss_hash . '::GET_FIRST' . '\\1=\\2', $str); $str = (string)\preg_replace('|\&([a-z\_0-9\-]+)\=([a-z\_0-9\-/]+)|i', $this->_xss_hash . '::GET_NEXT' . '\\1=\\2', $str); return \str_replace( [ $this->_xss_hash . '::GET_FIRST', $this->_xss_hash . '::GET_NEXT', ], [ '?', '&', ], $this->_entity_decode($str) ); } private function _do($str) { $str = (string)$str; $strInt = (int)$str; $strFloat = (float)$str; if ( !$str || "$strInt" == $str || "$strFloat" == $str ) { if ($this->xss_found !== true) { $this->xss_found = false; } return $str; } $str = UTF8::clean( $str, true, true, false, false, true, true ); $str = $this->_repack_utf7($str); $str = $this->_decode_string($str); if ($this->_stripe_4byte_chars === true) { $str = (string)\preg_replace('/[\x{10000}-\x{10FFFF}]/u', '', $str); } $str_backup = $str; $str = $this->_do_never_allowed($str); $str = $this->_compact_exploded_javascript($str); $str = $this->_remove_disallowed_javascript($str); $str = $this->_remove_evil_attributes($str); $str = $this->_sanitize_naughty_javascript($str); $str = $this->_sanitize_naughty_html($str); $str = $this->_do_never_allowed_afterwards($str); if ($this->xss_found !== true) { $this->xss_found = !($str_backup === $str); } return $str; } private function _do_never_allowed(string $str): string { static $NEVER_ALLOWED_CACHE = []; $NEVER_ALLOWED_CACHE['keys'] = null; $NEVER_ALLOWED_CACHE['regex'] = null; if (null === $NEVER_ALLOWED_CACHE['keys']) { $NEVER_ALLOWED_CACHE['keys'] = \array_keys($this->_never_allowed_str); } $str = \str_ireplace($NEVER_ALLOWED_CACHE['keys'], $this->_never_allowed_str, $str); if (null === $NEVER_ALLOWED_CACHE['regex']) { $NEVER_ALLOWED_CACHE['regex'] = \implode('|', self::$_never_allowed_regex); } $str = (string)\preg_replace('#' . $NEVER_ALLOWED_CACHE['regex'] . '#is', $this->_replacement, $str); return $str; } private function _do_never_allowed_afterwards(string $str): string { static $NEVER_ALLOWED_STR_AFTERWARDS_CACHE; if (null === $NEVER_ALLOWED_STR_AFTERWARDS_CACHE) { foreach (self::$_never_allowed_str_afterwards as &$neverAllowedStr) { $neverAllowedStr .= '.*='; } unset($neverAllowedStr); $NEVER_ALLOWED_STR_AFTERWARDS_CACHE = \implode('|', self::$_never_allowed_str_afterwards); } $str = (string)\preg_replace('#' . $NEVER_ALLOWED_STR_AFTERWARDS_CACHE . '#isU', $this->_replacement, $str); return $str; } private function _entity_decode(string $str): string { static $HTML_ENTITIES_CACHE; $flags = ENT_QUOTES | ENT_HTML5 | ENT_DISALLOWED | ENT_SUBSTITUTE; if (strpos($str, $this->_xss_hash) !== false) { $str = UTF8::html_entity_decode($str, $flags); } else { $str = UTF8::rawurldecode($str); } if (preg_match_all('/&[A-Za-z]{2,}[;]{0}/', $str, $matches)) { if (null === $HTML_ENTITIES_CACHE) { $entitiesSecurity = [ '&#x00000;' => '', '&#0;' => '', '&#x00001;' => '', '&#1;' => '', '&nvgt;' => '', '&#61253;' => '', '&#x0EF45;' => '', '&shy;' => '', '&#x000AD;' => '', '&#173;' => '', '&colon;' => ':', '&#x0003A;' => ':', '&#58;' => ':', '&lpar;' => '(', '&#x00028;' => '(', '&#40;' => '(', '&rpar;' => ')', '&#x00029;' => ')', '&#41;' => ')', '&quest;' => '?', '&#x0003F;' => '?', '&#63;' => '?', '&sol;' => '/', '&#x0002F;' => '/', '&#47;' => '/', '&apos;' => '\'', '&#x00027;' => '\'', '&#039;' => '\'', '&#39;' => '\'', '&#x27;' => '\'', '&bsol;' => '\'', '&#x0005C;' => '\\', '&#92;' => '\\', '&comma;' => ',', '&#x0002C;' => ',', '&#44;' => ',', '&period;' => '.', '&#x0002E;' => '.', '&quot;' => '"', '&QUOT;' => '"', '&#x00022;' => '"', '&#34;' => '"', '&grave;' => '`', '&DiacriticalGrave;' => '`', '&#x00060;' => '`', '&#96;' => '`', '&#46;' => '.', '&equals;' => '=', '&#x0003D;' => '=', '&#61;' => '=', '&newline;' => "\n", '&#x0000A;' => "\n", '&#10;' => "\n", '&tab;' => "\t", '&#x00009;' => "\t", '&#9;' => "\t", ]; $HTML_ENTITIES_CACHE = \array_merge( $entitiesSecurity, \array_flip(\get_html_translation_table(HTML_ENTITIES, $flags)), \array_flip(self::$entitiesFallback) ); } $replace = []; foreach ($matches[0] as $match) { $match .= ';'; if (isset($HTML_ENTITIES_CACHE[$match])) { $replace[$match] = $HTML_ENTITIES_CACHE[$match]; } } if (\count($replace) > 0) { $str = \str_replace(\array_keys($replace), \array_values($replace), $str); } } return $str; } private function _filter_attributes(string $str): string { if ($str === '') { return ''; } $out = ''; if ( \preg_match_all('#\s*[A-Za-z\-]+\s*=\s*("|\042|\'|\047)([^\\1]*?)\\1#', $str, $matches) || ( $this->_replacement && \preg_match_all('#\s*[a-zA-Z\-]+\s*=' . \preg_quote($this->_replacement, '#') . '$#', $str, $matches) ) ) { foreach ($matches[0] as $match) { $out .= $match; } } return $out; } private function _initNeverAllowedStr() { $this->_never_allowed_str = [ 'document.cookie' => $this->_replacement, 'document.write' => $this->_replacement, '.parentNode' => $this->_replacement, '.innerHTML' => $this->_replacement, '.appendChild' => $this->_replacement, '-moz-binding' => $this->_replacement, '<!--' => '&lt;!--', '-->' => '--&gt;', '<?' => '&lt;?', '?>' => '?&gt;', '<![CDATA[' => '&lt;![CDATA[', '<!ENTITY' => '&lt;!ENTITY', '<!DOCTYPE' => '&lt;!DOCTYPE', '<!ATTLIST' => '&lt;!ATTLIST', ]; } private function _js_link_removal_callback(array $match): string { return $this->_js_removal_callback($match, 'href'); } private function _js_removal_callback(array $match, string $search): string { if (!$match[0]) { return ''; } $replacer = $this->_filter_attributes(\str_replace(['<', '>',], '', $match[1])); $pattern = '#' . $search . '=.*(?:\(.+([^\)]*?)(?:\)|$)|javascript:|view-source:|livescript:|wscript:|vbscript:|mocha:|charset=|window\.|document\.|\.cookie|<script|d\s*a\s*t\s*a\s*:)#is'; $matchInner = []; \preg_match($pattern, $match[1], $matchInner); if (\count($matchInner) > 0) { $replacer = (string)\preg_replace( $pattern, $search . '="' . $this->_replacement . '"', $replacer ); } return \str_ireplace($match[1], $replacer, $match[0]); } private function _js_src_removal_callback(array $match): string { return $this->_js_removal_callback($match, 'src'); } private function _sanitize_naughty_html_callback(array $matches): string { return '&lt;' . $matches[1] . $matches[2] . $matches[3] . \str_replace( [ '>', '<', ], [ '&gt;', '&lt;', ], $matches[4] ); } public function addEvilAttributes(array $strings) { $this->_evil_attributes = \array_merge($strings, $this->_evil_attributes); return $this; } public function addEvilHtmlTags(array $strings) { $this->_evil_html_tags = \array_merge($strings, $this->_evil_html_tags); return $this; } private function _compact_exploded_javascript(string $str): string { static $WORDS_CACHE; $words = [ 'javascript', 'expression', 'view-source', 'vbscript', 'jscript', 'wscript', 'vbs', 'script', 'base64', 'applet', 'alert', 'document', 'write', 'cookie', 'window', 'confirm', 'prompt', 'eval', ]; foreach ($words as $word) { if (!isset($WORDS_CACHE[$word])) { $regex = '(?:\s|\+|"|\042|\'|\047)*'; $word = $WORDS_CACHE[$word] = \substr( \chunk_split($word, 1, $regex), 0, -\strlen($regex) ); } else { $word = $WORDS_CACHE[$word]; } $str = (string)\preg_replace_callback( '#(' . $word . ')(\W)#is', [ $this, '_compact_exploded_words_callback', ], $str ); } return $str; } private function _decode_string(string $str): string { $regExForHtmlTags = '/<\w+.*+/si'; if (\preg_match($regExForHtmlTags, $str, $matches) === 1) { $str = (string)\preg_replace_callback( $regExForHtmlTags, [ $this, '_decode_entity', ], $str ); } else { $str = UTF8::rawurldecode($str); } return $str; } public function isXssFound() { return $this->xss_found; } public function removeEvilAttributes(array $strings) { $this->_evil_attributes = \array_diff( $this->_evil_attributes, \array_intersect($strings, $this->_evil_attributes) ); return $this; } public function removeEvilHtmlTags(array $strings) { $this->_evil_html_tags = \array_diff( $this->_evil_html_tags, \array_intersect($strings, $this->_evil_html_tags) ); return $this; } private function _remove_disallowed_javascript($str): string { do { $original = $str; if (\stripos($str, '<a') !== false) { $str = (string)\preg_replace_callback( '#<a[^a-z0-9>]+([^>]*?)(?:>|$)#i', [ $this, '_js_link_removal_callback', ], $str ); } if (\stripos($str, '<img') !== false) { $str = (string)\preg_replace_callback( '#<img[^a-z0-9]+([^>]*?)(?:\s?/?>|$)#i', [ $this, '_js_src_removal_callback', ], $str ); } if (\stripos($str, '<audio') !== false) { $str = (string)\preg_replace_callback( '#<audio[^a-z0-9]+([^>]*?)(?:\s?/?>|$)#i', [ $this, '_js_src_removal_callback', ], $str ); } if (\stripos($str, '<video') !== false) { $str = (string)\preg_replace_callback( '#<video[^a-z0-9]+([^>]*?)(?:\s?/?>|$)#i', [ $this, '_js_src_removal_callback', ], $str ); } if (\stripos($str, '<source') !== false) { $str = (string)\preg_replace_callback( '#<source[^a-z0-9]+([^>]*?)(?:\s?/?>|$)#i', [ $this, '_js_src_removal_callback', ], $str ); } if (\stripos($str, 'script') !== false) { $str = (string)\preg_replace('#(?:¼|<)/*(?:script).*(?:¾|>)#isuU', $this->_replacement, $str); } } while ($original !== $str); return (string)$str; } private function _remove_evil_attributes($str): string { if (\in_array('style', $this->_evil_attributes, true)) { do { $count = $temp_count = 0; $str = (string)\preg_replace( '/(<[^>]+)(?<!\w)(style\s*=\s*"(:?[^"]*?)"|style\s*=\s*\'(:?[^\']*?)\')/i', '$1' . $this->_replacement, $str, -1, $temp_count ); $count += $temp_count; } while ($count); } $evil_attributes_string = \implode('|', $this->_evil_attributes); do { $count = $temp_count = 0; $str = (string)\preg_replace( '/(.*)((?:<[^>]+)(?<!\w))(?:' . $evil_attributes_string . ')(?:\s*=\s*)(?:(?:\'|\047)(?:.*?)(?:\'|\047)|(?:"|\042)(?:.*?)(?:"|\042))(.*)/is', '$1$2' . $this->_replacement . '$3$4', $str, -1, $temp_count ); $count += $temp_count; $str = (string)\preg_replace( '/(.*)(<[^>]+)(?<!\w)(?:' . $evil_attributes_string . ')\s*=\s*(?:[^\s>]*)(.*)/is', '$1$2' . $this->_replacement . '$3', $str, -1, $temp_count ); $count += $temp_count; } while ($count); return (string)$str; } private function _repack_utf7($str): string { return \preg_replace_callback( '#\+([0-9a-zA-Z/]+)\-#', [$this, '_repack_utf7_callback'], $str ); } private function _repack_utf7_callback($str): string { $strTmp = \base64_decode($str[1]); if ($strTmp === false) { return $str; } $str = (string)\preg_replace_callback( '/^((?:\x00.)*?)((?:[^\x00].)+)/us', [$this, '_repack_utf7_callback_back'], $strTmp ); return \preg_replace('/\x00(.)/us', '$1', $str); } private function _repack_utf7_callback_back($str): string { return $str[1] . '+' . \rtrim(\base64_encode($str[2]), '=') . '-'; } private function _sanitize_naughty_html($str): string { $evil_html_tags = \implode('|', $this->_evil_html_tags); $str = (string)\preg_replace_callback( '#<(/*\s*)(' . $evil_html_tags . ')([^><]*)([><]*)#i', [ $this, '_sanitize_naughty_html_callback', ], $str ); return (string)$str; } private function _sanitize_naughty_javascript($str): string { $str = (string)\preg_replace( '#(alert|eval|prompt|confirm|cmd|passthru|eval|exec|expression|system|fopen|fsockopen|file|file_get_contents|readfile|unlink)(\s*)\((.*)\)#siU', '\\1\\2&#40;\\3&#41;', $str ); return (string)$str; } public function setReplacement($string) { $this->_replacement = (string)$string; $this->_initNeverAllowedStr(); return $this; } public function setStripe4byteChars($bool) { $this->_stripe_4byte_chars = (bool)$bool; return $this; } public function xss_clean($str) { $this->xss_found = null; if (\is_array($str) === true) { foreach ($str as $key => &$value) { $str[$key] = $this->xss_clean($value); } return $str; } do { $old_str = $str; $str = $this->_do($str); } while ($old_str !== $str); return $str; } private function _xss_hash(): string { if ($this->_xss_hash === null) { $rand = Bootup::get_random_bytes(16); if (!$rand) { $this->_xss_hash = \md5(\uniqid(\mt_rand(), true)); } else { $this->_xss_hash = \bin2hex($rand); } } return 'voku::anti-xss::' . $this->_xss_hash; } } 